//
//	MBsysTran - Release 8.1
//
//	Copyright 
//	Universite catholique de Louvain (UCLouvain) 
//	Mechatronic, Electrical Energy, and Dynamic systems (MEED Division) 
//	2, Place du Levant
//	1348 Louvain-la-Neuve 
//	Belgium 
//
//	http://www.robotran.be 
//
//	==> Generation Date: Tue Jan 30 09:17:41 2024
//
//	==> Project name: delta_fisette_c
//
//	==> Number of joints: 23
//
//	==> Function: F8 - Constraints and Constraints Jacobian(h, J)
//
//	==> Git hash: 9034ed7a9ff7b13e6df2e2fd994ccfc949192e56
//
//	==> Input XML
//

#include <math.h> 

#include "mbs_data.h"

void mbs_cons_hJ(double *h, double **Jac,
MbsData *s, double tsim)
{
#include "mbs_cons_hJ_delta_fisette_c.h"

double *q, *qd;
double **dpt, *lrod;

q = s->q;
qd = s->qd;

dpt = s->dpt;
lrod = s->lrod;
 
// Trigonometric functions

S19 = sin(q[19]);
C19 = cos(q[19]);
S20 = sin(q[20]);
C20 = cos(q[20]);
S21 = sin(q[21]);
C21 = cos(q[21]);
S22 = sin(q[22]);
C22 = cos(q[22]);
S8 = sin(q[8]);
C8 = cos(q[8]);
S9 = sin(q[9]);
C9 = cos(q[9]);
S10 = sin(q[10]);
C10 = cos(q[10]);
S11 = sin(q[11]);
C11 = cos(q[11]);
S12 = sin(q[12]);
C12 = cos(q[12]);
S4 = sin(q[4]);
C4 = cos(q[4]);
S5 = sin(q[5]);
C5 = cos(q[5]);
S14 = sin(q[14]);
C14 = cos(q[14]);
S15 = sin(q[15]);
C15 = cos(q[15]);
S16 = sin(q[16]);
C16 = cos(q[16]);
S17 = sin(q[17]);
C17 = cos(q[17]);
S6 = sin(q[6]);
C6 = cos(q[6]);
S7 = sin(q[7]);
C7 = cos(q[7]);
 
// Augmented Joint Position Vectors

 
// Constraints and Constraints Jacobian

ROlp1_12 = C19*C20;
ROlp1_22 = S19*C20;
ROlp1_72 = C19*S20;
ROlp1_82 = S19*S20;
ROlp1_13 = ROlp1_12*C21-ROlp1_72*S21;
ROlp1_23 = ROlp1_22*C21-ROlp1_82*S21;
ROlp1_33 = -C20*S21-S20*C21;
ROlp1_73 = ROlp1_12*S21+ROlp1_72*C21;
ROlp1_83 = ROlp1_22*S21+ROlp1_82*C21;
ROlp1_93 = C20*C21-S20*S21;
ROlp1_74 = ROlp1_73*C22+S19*S22;
ROlp1_84 = ROlp1_83*C22-C19*S22;
ROlp1_94 = ROlp1_93*C22;
RLlp1_13 = ROlp1_72*dpt[3][19];
RLlp1_23 = ROlp1_82*dpt[3][19];
RLlp1_33 = dpt[3][19]*C20;
POlp1_13 = RLlp1_13+dpt[1][3];
POlp1_23 = RLlp1_23+dpt[2][3];
JTlp1_13_2 = RLlp1_33*C19;
JTlp1_23_2 = RLlp1_33*S19;
JTlp1_33_2 = -RLlp1_13*C19-RLlp1_23*S19;
RLlp1_14 = -dpt[2][20]*S19;
RLlp1_24 = dpt[2][20]*C19;
POlp1_14 = POlp1_13+RLlp1_14;
POlp1_24 = POlp1_23+RLlp1_24;
JTlp1_14_1 = -RLlp1_23-RLlp1_24;
JTlp1_24_1 = RLlp1_13+RLlp1_14;
JTlp1_34_2 = JTlp1_33_2-RLlp1_14*C19-RLlp1_24*S19;
JTlp1_34_3 = -RLlp1_14*C19-RLlp1_24*S19;
RLlp1_15 = ROlp1_74*dpt[3][22];
RLlp1_25 = ROlp1_84*dpt[3][22];
RLlp1_35 = ROlp1_94*dpt[3][22];
POlp1_15 = POlp1_14+RLlp1_15;
POlp1_25 = POlp1_24+RLlp1_25;
POlp1_35 = RLlp1_33+RLlp1_35;
JTlp1_15_1 = JTlp1_14_1-RLlp1_25;
JTlp1_25_1 = JTlp1_24_1+RLlp1_15;
JTlp1_15_2 = JTlp1_13_2+RLlp1_35*C19;
JTlp1_25_2 = JTlp1_23_2+RLlp1_35*S19;
JTlp1_35_2 = JTlp1_34_2-RLlp1_15*C19-RLlp1_25*S19;
JTlp1_15_3 = RLlp1_35*C19;
JTlp1_25_3 = RLlp1_35*S19;
JTlp1_35_3 = JTlp1_34_3-RLlp1_15*C19-RLlp1_25*S19;
JTlp1_15_4 = -RLlp1_25*ROlp1_33+RLlp1_35*ROlp1_23;
JTlp1_25_4 = RLlp1_15*ROlp1_33-RLlp1_35*ROlp1_13;
JTlp1_35_4 = -RLlp1_15*ROlp1_23+RLlp1_25*ROlp1_13;
POlp2_14 = q[1]+dpt[1][6];
POlp2_24 = q[2]+dpt[2][6];
RLlp2_16 = -dpt[2][10]*S8;
RLlp2_26 = dpt[2][10]*C8;
POlp2_16 = POlp2_14+RLlp2_16;
POlp2_26 = POlp2_24+RLlp2_26;
JTlp2_36_5 = -RLlp2_16*C8-RLlp2_26*S8;
h_1 = POlp1_15-POlp2_16;
h_2 = POlp1_25-POlp2_26;
h_3 = POlp1_35-q[3];
ROlp3_12 = C10*C11-S10*S11;
ROlp3_32 = -C10*S11-S10*C11;
ROlp3_72 = C10*S11+S10*C11;
ROlp3_92 = C10*C11-S10*S11;
ROlp3_73 = ROlp3_72*C12;
ROlp3_93 = ROlp3_92*C12;
RLlp3_12 = dpt[3][11]*S10;
RLlp3_32 = dpt[3][11]*C10;
POlp3_12 = RLlp3_12+dpt[1][1];
RLlp3_14 = ROlp3_73*dpt[3][14];
RLlp3_24 = -dpt[3][14]*S12;
RLlp3_34 = ROlp3_93*dpt[3][14];
POlp3_14 = POlp3_12+RLlp3_14;
POlp3_24 = RLlp3_24+dpt[2][12];
POlp3_34 = RLlp3_32+RLlp3_34;
JTlp3_14_1 = RLlp3_32+RLlp3_34;
JTlp3_34_1 = -RLlp3_12-RLlp3_14;
JTlp3_14_3 = -RLlp3_24*ROlp3_32;
JTlp3_24_3 = RLlp3_14*ROlp3_32-RLlp3_34*ROlp3_12;
JTlp3_34_3 = RLlp3_24*ROlp3_12;
POlp4_14 = q[1]+dpt[1][4];
RLlp4_16 = -dpt[2][8]*S4;
RLlp4_26 = dpt[2][8]*C4;
POlp4_16 = POlp4_14+RLlp4_16;
POlp4_26 = RLlp4_26+q[2];
JTlp4_36_5 = -RLlp4_16*C4-RLlp4_26*S4;
h_4 = POlp3_14-POlp4_16;
h_5 = POlp3_24-POlp4_26;
h_6 = POlp3_34-q[3];
ROlp5_12 = C14*C15;
ROlp5_22 = S14*C15;
ROlp5_72 = C14*S15;
ROlp5_82 = S14*S15;
ROlp5_13 = ROlp5_12*C16-ROlp5_72*S16;
ROlp5_23 = ROlp5_22*C16-ROlp5_82*S16;
ROlp5_33 = -C15*S16-S15*C16;
ROlp5_73 = ROlp5_12*S16+ROlp5_72*C16;
ROlp5_83 = ROlp5_22*S16+ROlp5_82*C16;
ROlp5_93 = C15*C16-S15*S16;
ROlp5_74 = ROlp5_73*C17+S14*S17;
ROlp5_84 = ROlp5_83*C17-C14*S17;
ROlp5_94 = ROlp5_93*C17;
RLlp5_13 = ROlp5_72*dpt[3][15];
RLlp5_23 = ROlp5_82*dpt[3][15];
RLlp5_33 = dpt[3][15]*C15;
POlp5_13 = RLlp5_13+dpt[1][2];
POlp5_23 = RLlp5_23+dpt[2][2];
JTlp5_13_2 = RLlp5_33*C14;
JTlp5_23_2 = RLlp5_33*S14;
JTlp5_33_2 = -RLlp5_13*C14-RLlp5_23*S14;
RLlp5_14 = -dpt[2][16]*S14;
RLlp5_24 = dpt[2][16]*C14;
POlp5_14 = POlp5_13+RLlp5_14;
POlp5_24 = POlp5_23+RLlp5_24;
JTlp5_14_1 = -RLlp5_23-RLlp5_24;
JTlp5_24_1 = RLlp5_13+RLlp5_14;
JTlp5_34_2 = JTlp5_33_2-RLlp5_14*C14-RLlp5_24*S14;
JTlp5_34_3 = -RLlp5_14*C14-RLlp5_24*S14;
RLlp5_15 = ROlp5_74*dpt[3][18];
RLlp5_25 = ROlp5_84*dpt[3][18];
RLlp5_35 = ROlp5_94*dpt[3][18];
POlp5_15 = POlp5_14+RLlp5_15;
POlp5_25 = POlp5_24+RLlp5_25;
POlp5_35 = RLlp5_33+RLlp5_35;
JTlp5_15_1 = JTlp5_14_1-RLlp5_25;
JTlp5_25_1 = JTlp5_24_1+RLlp5_15;
JTlp5_15_2 = JTlp5_13_2+RLlp5_35*C14;
JTlp5_25_2 = JTlp5_23_2+RLlp5_35*S14;
JTlp5_35_2 = JTlp5_34_2-RLlp5_15*C14-RLlp5_25*S14;
JTlp5_15_3 = RLlp5_35*C14;
JTlp5_25_3 = RLlp5_35*S14;
JTlp5_35_3 = JTlp5_34_3-RLlp5_15*C14-RLlp5_25*S14;
JTlp5_15_4 = -RLlp5_25*ROlp5_33+RLlp5_35*ROlp5_23;
JTlp5_25_4 = RLlp5_15*ROlp5_33-RLlp5_35*ROlp5_13;
JTlp5_35_4 = -RLlp5_15*ROlp5_23+RLlp5_25*ROlp5_13;
POlp6_14 = q[1]+dpt[1][5];
POlp6_24 = q[2]+dpt[2][5];
RLlp6_16 = -dpt[2][9]*S6;
RLlp6_26 = dpt[2][9]*C6;
POlp6_16 = POlp6_14+RLlp6_16;
POlp6_26 = POlp6_24+RLlp6_26;
JTlp6_36_5 = -RLlp6_16*C6-RLlp6_26*S6;
h_7 = POlp5_15-POlp6_16;
h_8 = POlp5_25-POlp6_26;
h_9 = POlp5_35-q[3];
h[1] = h_1;
h[2] = h_2;
h[3] = h_3;
h[4] = h_4;
h[5] = h_5;
h[6] = h_6;
h[7] = h_7;
h[8] = h_8;
h[9] = h_9;
Jac[1][1] = -(1.0);
Jac[1][2] = 0;
Jac[1][3] = 0;
Jac[1][4] = 0;
Jac[1][5] = 0;
Jac[1][6] = 0;
Jac[1][7] = 0;
Jac[1][8] = RLlp2_26;
Jac[1][9] = 0;
Jac[1][10] = 0;
Jac[1][11] = 0;
Jac[1][12] = 0;
Jac[1][13] = 0;
Jac[1][14] = 0;
Jac[1][15] = 0;
Jac[1][16] = 0;
Jac[1][17] = 0;
Jac[1][18] = 0;
Jac[1][19] = JTlp1_15_1;
Jac[1][20] = JTlp1_15_2;
Jac[1][21] = JTlp1_15_3;
Jac[1][22] = JTlp1_15_4;
Jac[1][23] = 0;
Jac[2][1] = 0;
Jac[2][2] = -(1.0);
Jac[2][3] = 0;
Jac[2][4] = 0;
Jac[2][5] = 0;
Jac[2][6] = 0;
Jac[2][7] = 0;
Jac[2][8] = -RLlp2_16;
Jac[2][9] = 0;
Jac[2][10] = 0;
Jac[2][11] = 0;
Jac[2][12] = 0;
Jac[2][13] = 0;
Jac[2][14] = 0;
Jac[2][15] = 0;
Jac[2][16] = 0;
Jac[2][17] = 0;
Jac[2][18] = 0;
Jac[2][19] = JTlp1_25_1;
Jac[2][20] = JTlp1_25_2;
Jac[2][21] = JTlp1_25_3;
Jac[2][22] = JTlp1_25_4;
Jac[2][23] = 0;
Jac[3][1] = 0;
Jac[3][2] = 0;
Jac[3][3] = -(1.0);
Jac[3][4] = 0;
Jac[3][5] = 0;
Jac[3][6] = 0;
Jac[3][7] = 0;
Jac[3][8] = 0;
Jac[3][9] = -JTlp2_36_5;
Jac[3][10] = 0;
Jac[3][11] = 0;
Jac[3][12] = 0;
Jac[3][13] = 0;
Jac[3][14] = 0;
Jac[3][15] = 0;
Jac[3][16] = 0;
Jac[3][17] = 0;
Jac[3][18] = 0;
Jac[3][19] = 0;
Jac[3][20] = JTlp1_35_2;
Jac[3][21] = JTlp1_35_3;
Jac[3][22] = JTlp1_35_4;
Jac[3][23] = 0;
Jac[4][1] = -(1.0);
Jac[4][2] = 0;
Jac[4][3] = 0;
Jac[4][4] = RLlp4_26;
Jac[4][5] = 0;
Jac[4][6] = 0;
Jac[4][7] = 0;
Jac[4][8] = 0;
Jac[4][9] = 0;
Jac[4][10] = JTlp3_14_1;
Jac[4][11] = RLlp3_34;
Jac[4][12] = JTlp3_14_3;
Jac[4][13] = 0;
Jac[4][14] = 0;
Jac[4][15] = 0;
Jac[4][16] = 0;
Jac[4][17] = 0;
Jac[4][18] = 0;
Jac[4][19] = 0;
Jac[4][20] = 0;
Jac[4][21] = 0;
Jac[4][22] = 0;
Jac[4][23] = 0;
Jac[5][1] = 0;
Jac[5][2] = -(1.0);
Jac[5][3] = 0;
Jac[5][4] = -RLlp4_16;
Jac[5][5] = 0;
Jac[5][6] = 0;
Jac[5][7] = 0;
Jac[5][8] = 0;
Jac[5][9] = 0;
Jac[5][10] = 0;
Jac[5][11] = 0;
Jac[5][12] = JTlp3_24_3;
Jac[5][13] = 0;
Jac[5][14] = 0;
Jac[5][15] = 0;
Jac[5][16] = 0;
Jac[5][17] = 0;
Jac[5][18] = 0;
Jac[5][19] = 0;
Jac[5][20] = 0;
Jac[5][21] = 0;
Jac[5][22] = 0;
Jac[5][23] = 0;
Jac[6][1] = 0;
Jac[6][2] = 0;
Jac[6][3] = -(1.0);
Jac[6][4] = 0;
Jac[6][5] = -JTlp4_36_5;
Jac[6][6] = 0;
Jac[6][7] = 0;
Jac[6][8] = 0;
Jac[6][9] = 0;
Jac[6][10] = JTlp3_34_1;
Jac[6][11] = -RLlp3_14;
Jac[6][12] = JTlp3_34_3;
Jac[6][13] = 0;
Jac[6][14] = 0;
Jac[6][15] = 0;
Jac[6][16] = 0;
Jac[6][17] = 0;
Jac[6][18] = 0;
Jac[6][19] = 0;
Jac[6][20] = 0;
Jac[6][21] = 0;
Jac[6][22] = 0;
Jac[6][23] = 0;
Jac[7][1] = -(1.0);
Jac[7][2] = 0;
Jac[7][3] = 0;
Jac[7][4] = 0;
Jac[7][5] = 0;
Jac[7][6] = RLlp6_26;
Jac[7][7] = 0;
Jac[7][8] = 0;
Jac[7][9] = 0;
Jac[7][10] = 0;
Jac[7][11] = 0;
Jac[7][12] = 0;
Jac[7][13] = 0;
Jac[7][14] = JTlp5_15_1;
Jac[7][15] = JTlp5_15_2;
Jac[7][16] = JTlp5_15_3;
Jac[7][17] = JTlp5_15_4;
Jac[7][18] = 0;
Jac[7][19] = 0;
Jac[7][20] = 0;
Jac[7][21] = 0;
Jac[7][22] = 0;
Jac[7][23] = 0;
Jac[8][1] = 0;
Jac[8][2] = -(1.0);
Jac[8][3] = 0;
Jac[8][4] = 0;
Jac[8][5] = 0;
Jac[8][6] = -RLlp6_16;
Jac[8][7] = 0;
Jac[8][8] = 0;
Jac[8][9] = 0;
Jac[8][10] = 0;
Jac[8][11] = 0;
Jac[8][12] = 0;
Jac[8][13] = 0;
Jac[8][14] = JTlp5_25_1;
Jac[8][15] = JTlp5_25_2;
Jac[8][16] = JTlp5_25_3;
Jac[8][17] = JTlp5_25_4;
Jac[8][18] = 0;
Jac[8][19] = 0;
Jac[8][20] = 0;
Jac[8][21] = 0;
Jac[8][22] = 0;
Jac[8][23] = 0;
Jac[9][1] = 0;
Jac[9][2] = 0;
Jac[9][3] = -(1.0);
Jac[9][4] = 0;
Jac[9][5] = 0;
Jac[9][6] = 0;
Jac[9][7] = -JTlp6_36_5;
Jac[9][8] = 0;
Jac[9][9] = 0;
Jac[9][10] = 0;
Jac[9][11] = 0;
Jac[9][12] = 0;
Jac[9][13] = 0;
Jac[9][14] = 0;
Jac[9][15] = JTlp5_35_2;
Jac[9][16] = JTlp5_35_3;
Jac[9][17] = JTlp5_35_4;
Jac[9][18] = 0;
Jac[9][19] = 0;
Jac[9][20] = 0;
Jac[9][21] = 0;
Jac[9][22] = 0;
Jac[9][23] = 0;

// Number of continuation lines = 0

}
