//
//	MBsysTran - Release 8.1
//
//	Copyright 
//	Universite catholique de Louvain (UCLouvain) 
//	Mechatronic, Electrical Energy, and Dynamic systems (MEED Division) 
//	2, Place du Levant
//	1348 Louvain-la-Neuve 
//	Belgium 
//
//	http://www.robotran.be 
//
//	==> Generation Date: Tue Jan 30 09:17:41 2024
//
//	==> Project name: delta_fisette_c
//
//	==> Number of joints: 23
//
//	==> Function: F18 - Constraints Quadratic Velocity Terms (Jdqd)
//
//	==> Git hash: 9034ed7a9ff7b13e6df2e2fd994ccfc949192e56
//
//	==> Input XML
//

#include <math.h> 

#include "mbs_data.h"

void mbs_cons_jdqd(double *Jdqd,
MbsData *s, double tsim)
{
#include "mbs_cons_jdqd_delta_fisette_c.h"

double *q, *qd;
double **dpt, *lrod;

q = s->q;
qd = s->qd;

dpt = s->dpt;
lrod = s->lrod;
 
// Trigonometric functions

S19 = sin(q[19]);
C19 = cos(q[19]);
S20 = sin(q[20]);
C20 = cos(q[20]);
S21 = sin(q[21]);
C21 = cos(q[21]);
S22 = sin(q[22]);
C22 = cos(q[22]);
S8 = sin(q[8]);
C8 = cos(q[8]);
S9 = sin(q[9]);
C9 = cos(q[9]);
S10 = sin(q[10]);
C10 = cos(q[10]);
S11 = sin(q[11]);
C11 = cos(q[11]);
S12 = sin(q[12]);
C12 = cos(q[12]);
S4 = sin(q[4]);
C4 = cos(q[4]);
S5 = sin(q[5]);
C5 = cos(q[5]);
S14 = sin(q[14]);
C14 = cos(q[14]);
S15 = sin(q[15]);
C15 = cos(q[15]);
S16 = sin(q[16]);
C16 = cos(q[16]);
S17 = sin(q[17]);
C17 = cos(q[17]);
S6 = sin(q[6]);
C6 = cos(q[6]);
S7 = sin(q[7]);
C7 = cos(q[7]);
 
// Augmented Joint Position Vectors

 
// Constraints and Constraints Jacobian

 
// Constraints Quadratic Terms

ROjdqd1_12 = C19*C20;
ROjdqd1_22 = S19*C20;
ROjdqd1_72 = C19*S20;
ROjdqd1_82 = S19*S20;
ROjdqd1_13 = ROjdqd1_12*C21-ROjdqd1_72*S21;
ROjdqd1_23 = ROjdqd1_22*C21-ROjdqd1_82*S21;
ROjdqd1_33 = -C20*S21-S20*C21;
ROjdqd1_73 = ROjdqd1_12*S21+ROjdqd1_72*C21;
ROjdqd1_83 = ROjdqd1_22*S21+ROjdqd1_82*C21;
ROjdqd1_93 = C20*C21-S20*S21;
ROjdqd1_74 = ROjdqd1_73*C22+S19*S22;
ROjdqd1_84 = ROjdqd1_83*C22-C19*S22;
ROjdqd1_94 = ROjdqd1_93*C22;
OMjdqd1_12 = -qd[20]*S19;
OMjdqd1_22 = qd[20]*C19;
RLjdqd1_13 = ROjdqd1_72*dpt[3][19];
RLjdqd1_23 = ROjdqd1_82*dpt[3][19];
RLjdqd1_33 = dpt[3][19]*C20;
OMjdqd1_13 = OMjdqd1_12-qd[21]*S19;
OMjdqd1_23 = OMjdqd1_22+qd[21]*C19;
ORjdqd1_13 = OMjdqd1_22*RLjdqd1_33;
ORjdqd1_23 = -OMjdqd1_12*RLjdqd1_33;
ORjdqd1_33 = OMjdqd1_12*RLjdqd1_23-OMjdqd1_22*RLjdqd1_13;
Ompqpjdqd1_33 = qd[21]*(OMjdqd1_12*C19+OMjdqd1_22*S19);
Apqpjdqd1_13 = OMjdqd1_22*ORjdqd1_33;
Apqpjdqd1_23 = -OMjdqd1_12*ORjdqd1_33;
Apqpjdqd1_33 = OMjdqd1_12*ORjdqd1_23-OMjdqd1_22*ORjdqd1_13;
RLjdqd1_14 = -dpt[2][20]*S19;
RLjdqd1_24 = dpt[2][20]*C19;
OMjdqd1_14 = OMjdqd1_13+ROjdqd1_13*qd[22];
OMjdqd1_24 = OMjdqd1_23+ROjdqd1_23*qd[22];
OMjdqd1_34 = ROjdqd1_33*qd[22];
ORjdqd1_34 = OMjdqd1_13*RLjdqd1_24-OMjdqd1_23*RLjdqd1_14;
Ompqpjdqd1_14 = OMjdqd1_23*ROjdqd1_33*qd[22];
Ompqpjdqd1_24 = -OMjdqd1_13*ROjdqd1_33*qd[22];
Ompqpjdqd1_34 = Ompqpjdqd1_33+qd[22]*(OMjdqd1_13*ROjdqd1_23-OMjdqd1_23*ROjdqd1_13);
Apqpjdqd1_14 = Apqpjdqd1_13+OMjdqd1_23*ORjdqd1_34-Ompqpjdqd1_33*RLjdqd1_24;
Apqpjdqd1_24 = Apqpjdqd1_23-OMjdqd1_13*ORjdqd1_34+Ompqpjdqd1_33*RLjdqd1_14;
RLjdqd1_15 = ROjdqd1_74*dpt[3][22];
RLjdqd1_25 = ROjdqd1_84*dpt[3][22];
RLjdqd1_35 = ROjdqd1_94*dpt[3][22];
ORjdqd1_15 = OMjdqd1_24*RLjdqd1_35-OMjdqd1_34*RLjdqd1_25;
ORjdqd1_25 = -OMjdqd1_14*RLjdqd1_35+OMjdqd1_34*RLjdqd1_15;
ORjdqd1_35 = OMjdqd1_14*RLjdqd1_25-OMjdqd1_24*RLjdqd1_15;
Apqpjdqd1_15 = Apqpjdqd1_14+OMjdqd1_24*ORjdqd1_35-OMjdqd1_34*ORjdqd1_25+Ompqpjdqd1_24*RLjdqd1_35-Ompqpjdqd1_34*
 RLjdqd1_25;
Apqpjdqd1_25 = Apqpjdqd1_24-OMjdqd1_14*ORjdqd1_35+OMjdqd1_34*ORjdqd1_15-Ompqpjdqd1_14*RLjdqd1_35+Ompqpjdqd1_34*
 RLjdqd1_15;
Apqpjdqd1_35 = Apqpjdqd1_33+OMjdqd1_14*ORjdqd1_25-OMjdqd1_24*ORjdqd1_15+Ompqpjdqd1_14*RLjdqd1_25-Ompqpjdqd1_24*
 RLjdqd1_15;
ROjdqd3_12 = C10*C11-S10*S11;
ROjdqd3_32 = -C10*S11-S10*C11;
ROjdqd3_72 = C10*S11+S10*C11;
ROjdqd3_92 = C10*C11-S10*S11;
ROjdqd3_73 = ROjdqd3_72*C12;
ROjdqd3_93 = ROjdqd3_92*C12;
RLjdqd3_12 = dpt[3][11]*S10;
RLjdqd3_32 = dpt[3][11]*C10;
OMjdqd3_22 = qd[10]+qd[11];
ORjdqd3_12 = RLjdqd3_32*qd[10];
ORjdqd3_32 = -RLjdqd3_12*qd[10];
Apqpjdqd3_12 = ORjdqd3_32*qd[10];
Apqpjdqd3_32 = -ORjdqd3_12*qd[10];
OMjdqd3_13 = ROjdqd3_12*qd[12];
OMjdqd3_33 = ROjdqd3_32*qd[12];
Ompqpjdqd3_13 = OMjdqd3_22*ROjdqd3_32*qd[12];
Ompqpjdqd3_33 = -OMjdqd3_22*ROjdqd3_12*qd[12];
RLjdqd3_14 = ROjdqd3_73*dpt[3][14];
RLjdqd3_24 = -dpt[3][14]*S12;
RLjdqd3_34 = ROjdqd3_93*dpt[3][14];
ORjdqd3_14 = OMjdqd3_22*RLjdqd3_34-OMjdqd3_33*RLjdqd3_24;
ORjdqd3_24 = -OMjdqd3_13*RLjdqd3_34+OMjdqd3_33*RLjdqd3_14;
ORjdqd3_34 = OMjdqd3_13*RLjdqd3_24-OMjdqd3_22*RLjdqd3_14;
Apqpjdqd3_14 = Apqpjdqd3_12+OMjdqd3_22*ORjdqd3_34-OMjdqd3_33*ORjdqd3_24-Ompqpjdqd3_33*RLjdqd3_24;
Apqpjdqd3_24 = -OMjdqd3_13*ORjdqd3_34+OMjdqd3_33*ORjdqd3_14-Ompqpjdqd3_13*RLjdqd3_34+Ompqpjdqd3_33*RLjdqd3_14;
Apqpjdqd3_34 = Apqpjdqd3_32+OMjdqd3_13*ORjdqd3_24-OMjdqd3_22*ORjdqd3_14+Ompqpjdqd3_13*RLjdqd3_24;
ROjdqd5_12 = C14*C15;
ROjdqd5_22 = S14*C15;
ROjdqd5_72 = C14*S15;
ROjdqd5_82 = S14*S15;
ROjdqd5_13 = ROjdqd5_12*C16-ROjdqd5_72*S16;
ROjdqd5_23 = ROjdqd5_22*C16-ROjdqd5_82*S16;
ROjdqd5_33 = -C15*S16-S15*C16;
ROjdqd5_73 = ROjdqd5_12*S16+ROjdqd5_72*C16;
ROjdqd5_83 = ROjdqd5_22*S16+ROjdqd5_82*C16;
ROjdqd5_93 = C15*C16-S15*S16;
ROjdqd5_74 = ROjdqd5_73*C17+S14*S17;
ROjdqd5_84 = ROjdqd5_83*C17-C14*S17;
ROjdqd5_94 = ROjdqd5_93*C17;
OMjdqd5_12 = -qd[15]*S14;
OMjdqd5_22 = qd[15]*C14;
RLjdqd5_13 = ROjdqd5_72*dpt[3][15];
RLjdqd5_23 = ROjdqd5_82*dpt[3][15];
RLjdqd5_33 = dpt[3][15]*C15;
OMjdqd5_13 = OMjdqd5_12-qd[16]*S14;
OMjdqd5_23 = OMjdqd5_22+qd[16]*C14;
ORjdqd5_13 = OMjdqd5_22*RLjdqd5_33;
ORjdqd5_23 = -OMjdqd5_12*RLjdqd5_33;
ORjdqd5_33 = OMjdqd5_12*RLjdqd5_23-OMjdqd5_22*RLjdqd5_13;
Ompqpjdqd5_33 = qd[16]*(OMjdqd5_12*C14+OMjdqd5_22*S14);
Apqpjdqd5_13 = OMjdqd5_22*ORjdqd5_33;
Apqpjdqd5_23 = -OMjdqd5_12*ORjdqd5_33;
Apqpjdqd5_33 = OMjdqd5_12*ORjdqd5_23-OMjdqd5_22*ORjdqd5_13;
RLjdqd5_14 = -dpt[2][16]*S14;
RLjdqd5_24 = dpt[2][16]*C14;
OMjdqd5_14 = OMjdqd5_13+ROjdqd5_13*qd[17];
OMjdqd5_24 = OMjdqd5_23+ROjdqd5_23*qd[17];
OMjdqd5_34 = ROjdqd5_33*qd[17];
ORjdqd5_34 = OMjdqd5_13*RLjdqd5_24-OMjdqd5_23*RLjdqd5_14;
Ompqpjdqd5_14 = OMjdqd5_23*ROjdqd5_33*qd[17];
Ompqpjdqd5_24 = -OMjdqd5_13*ROjdqd5_33*qd[17];
Ompqpjdqd5_34 = Ompqpjdqd5_33+qd[17]*(OMjdqd5_13*ROjdqd5_23-OMjdqd5_23*ROjdqd5_13);
Apqpjdqd5_14 = Apqpjdqd5_13+OMjdqd5_23*ORjdqd5_34-Ompqpjdqd5_33*RLjdqd5_24;
Apqpjdqd5_24 = Apqpjdqd5_23-OMjdqd5_13*ORjdqd5_34+Ompqpjdqd5_33*RLjdqd5_14;
RLjdqd5_15 = ROjdqd5_74*dpt[3][18];
RLjdqd5_25 = ROjdqd5_84*dpt[3][18];
RLjdqd5_35 = ROjdqd5_94*dpt[3][18];
ORjdqd5_15 = OMjdqd5_24*RLjdqd5_35-OMjdqd5_34*RLjdqd5_25;
ORjdqd5_25 = -OMjdqd5_14*RLjdqd5_35+OMjdqd5_34*RLjdqd5_15;
ORjdqd5_35 = OMjdqd5_14*RLjdqd5_25-OMjdqd5_24*RLjdqd5_15;
Apqpjdqd5_15 = Apqpjdqd5_14+OMjdqd5_24*ORjdqd5_35-OMjdqd5_34*ORjdqd5_25+Ompqpjdqd5_24*RLjdqd5_35-Ompqpjdqd5_34*
 RLjdqd5_25;
Apqpjdqd5_25 = Apqpjdqd5_24-OMjdqd5_14*ORjdqd5_35+OMjdqd5_34*ORjdqd5_15-Ompqpjdqd5_14*RLjdqd5_35+Ompqpjdqd5_34*
 RLjdqd5_15;
Apqpjdqd5_35 = Apqpjdqd5_33+OMjdqd5_14*ORjdqd5_25-OMjdqd5_24*ORjdqd5_15+Ompqpjdqd5_14*RLjdqd5_25-Ompqpjdqd5_24*
 RLjdqd5_15;
Jdqd[1] = Apqpjdqd1_15;
Jdqd[2] = Apqpjdqd1_25;
Jdqd[3] = Apqpjdqd1_35;
Jdqd[4] = Apqpjdqd3_14;
Jdqd[5] = Apqpjdqd3_24;
Jdqd[6] = Apqpjdqd3_34;
Jdqd[7] = Apqpjdqd5_15;
Jdqd[8] = Apqpjdqd5_25;
Jdqd[9] = Apqpjdqd5_35;

// Number of continuation lines = 1

}
