//
//	MBsysTran - Release 8.1
//
//	Copyright 
//	Universite catholique de Louvain (UCLouvain) 
//	Mechatronic, Electrical Energy, and Dynamic systems (MEED Division) 
//	2, Place du Levant
//	1348 Louvain-la-Neuve 
//	Belgium 
//
//	http://www.robotran.be 
//
//	==> Generation Date: Tue Jan 30 09:17:41 2024
//
//	==> Project name: delta_fisette_c
//
//	==> Number of joints: 23
//
//	==> Function: F6 - Sensors Kinematics
//
//	==> Git hash: 9034ed7a9ff7b13e6df2e2fd994ccfc949192e56
//
//	==> Input XML
//

#include <math.h> 

#include "mbs_data.h"
#include "mbs_sensor.h"

void mbs_sensor(MbsSensor *sens,
MbsData *s, int isens)
{
#include "mbs_sensor_delta_fisette_c.h"

double *q, *qd, *qdd;
double **dpt;

q = s->q;
qd = s->qd;
qdd = s->qdd;

dpt = s->dpt;
 
// Augmented Joint Position Vectors

 
// Sensor Kinematics


switch(isens)
{
case 1:

POcp1_34 = q[3]+dpt[3][7];
sens->P[1] = q[1];
sens->P[2] = q[2];
sens->P[3] = POcp1_34;
sens->R[1][1] = (1.0);
sens->R[2][2] = (1.0);
sens->R[3][3] = (1.0);
sens->V[1] = qd[1];
sens->V[2] = qd[2];
sens->V[3] = qd[3];
sens->OM[1] = 0;
sens->OM[2] = 0;
sens->OM[3] = 0;
sens->J[1][1] = (1.0);
sens->J[2][2] = (1.0);
sens->J[3][3] = (1.0);
sens->A[1] = qdd[1];
sens->A[2] = qdd[2];
sens->A[3] = qdd[3];
sens->OMP[1] = 0;
sens->OMP[2] = 0;
sens->OMP[3] = 0;

break;

default:

break;

}


// Number of continuation lines = 0

}
