%
%-------------------------------------------------------------
%
%	ROBOTRAN - Version 6.6 (build : february 22, 2008)
%
%	Copyright 
%	Universite catholique de Louvain 
%	Departement de Mecanique 
%	Unite de Production Mecanique et Machines 
%	2, Place du Levant 
%	1348 Louvain-la-Neuve 
%	http://www.robotran.be// 
%
%	==> Generation Date : Wed Nov  6 15:34:11 2019
%
%	==> Project name : delta_fisette_matlab
%	==> using XML input file 
%
%	==> Number of joints : 23
%
%	==> Function : F 8 : Constraints Vector (h) and Jacobian Matrix (Jac) 
%	==> Flops complexity : 216
%
%	==> Generation Time :  0.010 seconds
%	==> Post-Processing :  0.000 seconds
%
%-------------------------------------------------------------
%
function [h,Jac] = cons_hJ(s,tsim,usrfun)

 h = zeros(9,1);
 Jac = zeros(9,23);

q = s.q; 
qd = s.qd; 
qdd = s.qdd; 
frc = s.frc; 
trq = s.trq; 

% === begin imp_aux === 

% === end imp_aux === 

% ===== BEGIN task 0 ===== 

% = = Block_0_0_0_0_0_2 = = 
 
% Trigonometric Variables  

  C4 = cos(q(4));
  S4 = sin(q(4));

% = = Block_0_0_0_0_0_3 = = 
 
% Trigonometric Variables  

  C6 = cos(q(6));
  S6 = sin(q(6));

% = = Block_0_0_0_0_0_4 = = 
 
% Trigonometric Variables  

  C8 = cos(q(8));
  S8 = sin(q(8));

% = = Block_0_0_0_0_0_5 = = 
 
% Trigonometric Variables  

  C10 = cos(q(10));
  S10 = sin(q(10));
  C11 = cos(q(11));
  S11 = sin(q(11));

% = = Block_0_0_0_0_0_6 = = 
 
% Trigonometric Variables  

  C12 = cos(q(12));
  S12 = sin(q(12));

% = = Block_0_0_0_0_0_8 = = 
 
% Trigonometric Variables  

  C14 = cos(q(14));
  S14 = sin(q(14));
  C15 = cos(q(15));
  S15 = sin(q(15));
  C16 = cos(q(16));
  S16 = sin(q(16));

% = = Block_0_0_0_0_0_9 = = 
 
% Trigonometric Variables  

  C17 = cos(q(17));
  S17 = sin(q(17));

% = = Block_0_0_0_0_0_11 = = 
 
% Trigonometric Variables  

  C19 = cos(q(19));
  S19 = sin(q(19));
  C20 = cos(q(20));
  S20 = sin(q(20));
  C21 = cos(q(21));
  S21 = sin(q(21));

% = = Block_0_0_0_0_0_12 = = 
 
% Trigonometric Variables  

  C22 = cos(q(22));
  S22 = sin(q(22));

% = = Block_0_1_0_0_0_2 = = 
 
% Constraints and Constraints Jacobian 

%
  RL_3_127 = -s.dpt(2,8)*S4;
  RL_3_227 = s.dpt(2,8)*C4;

% = = Block_0_1_0_0_0_3 = = 
 
% Constraints and Constraints Jacobian 

%
  RL_5_129 = -s.dpt(2,9)*S6;
  RL_5_229 = s.dpt(2,9)*C6;

% = = Block_0_1_0_0_0_4 = = 
 
% Constraints and Constraints Jacobian 

%
  RL_1_125 = -s.dpt(2,10)*S8;
  RL_1_225 = s.dpt(2,10)*C8;

% = = Block_0_1_0_0_0_5 = = 
 
% Trigonometric Variables  

%
  S10p11 = C10*S11+S10*C11;
  C10p11 = C10*C11-S10*S11;
 
% Constraints and Constraints Jacobian 

  RL_2_111 = s.dpt(3,11)*S10;
  RL_2_311 = s.dpt(3,11)*C10;

% = = Block_0_1_0_0_0_6 = = 
 
% Constraints and Constraints Jacobian 

%
  RL_2_126 = s.dpt(3,14)*C12*S10p11;
  RL_2_226 = -s.dpt(3,14)*S12;
  RL_2_326 = s.dpt(3,14)*C12*C10p11;
  JT_2_126_10 = RL_2_311+RL_2_326;
  JT_2_326_10 = -(RL_2_111+RL_2_126);
  JT_2_126_12 = RL_2_226*S10p11;
  JT_2_226_12 = -s.dpt(3,14)*C12;
  JT_2_326_12 = RL_2_226*C10p11;

% = = Block_0_1_0_0_0_8 = = 
 
% Trigonometric Variables  

%
  S15p16 = C15*S16+S15*C16;
  C15p16 = C15*C16-S15*S16;
 
% Constraints and Constraints Jacobian 

  RO_4_116 = C14*C15p16;
  RO_4_216 = S14*C15p16;
  RL_4_116 = s.dpt(3,15)*C14*S15;
  RL_4_216 = s.dpt(3,15)*S14*S15;
  RL_4_316 = s.dpt(3,15)*C15;

% = = Block_0_1_0_0_0_9 = = 
 
% Constraints and Constraints Jacobian 

%
  RL_4_117 = -s.dpt(2,16)*S14;
  RL_4_217 = s.dpt(2,16)*C14;
  RL_4_128 = s.dpt(3,18)*(C14*C17*S15p16+S14*S17);
  RL_4_228 = (S14*S15p16*C17-C14*S17)*s.dpt(3,18);
  RL_4_328 = s.dpt(3,18)*C17*C15p16;
  JT_4_128_14 = -(RL_4_216+RL_4_217+RL_4_228);
  JT_4_228_14 = RL_4_116+RL_4_117+RL_4_128;
  JT_4_128_15 = C14*(RL_4_316+RL_4_328);
  JT_4_228_15 = S14*(RL_4_316+RL_4_328);
  JT_4_328_15 = -(RL_4_128*C14+RL_4_228*S14+s.dpt(3,15)*S15);
  JT_4_128_16 = RL_4_328*C14;
  JT_4_228_16 = RL_4_328*S14;
  JT_4_328_16 = -(RL_4_128*C14+RL_4_228*S14);
  JT_4_128_17 = RL_4_228*S15p16+RL_4_328*RO_4_216;
  JT_4_228_17 = -(RL_4_128*S15p16+RL_4_328*RO_4_116);
  JT_4_328_17 = -(RL_4_128*RO_4_216-RL_4_228*RO_4_116);

% = = Block_0_1_0_0_0_11 = = 
 
% Trigonometric Variables  

%
  S20p21 = C20*S21+S20*C21;
  C20p21 = C20*C21-S20*S21;
 
% Constraints and Constraints Jacobian 

  RO_0_121 = C19*C20p21;
  RO_0_221 = S19*C20p21;
  RL_0_121 = s.dpt(3,19)*C19*S20;
  RL_0_221 = s.dpt(3,19)*S19*S20;
  RL_0_321 = s.dpt(3,19)*C20;

% = = Block_0_1_0_0_0_12 = = 
 
% Constraints and Constraints Jacobian 

%
  RL_0_122 = -s.dpt(2,20)*S19;
  RL_0_222 = s.dpt(2,20)*C19;
  RL_0_124 = s.dpt(3,22)*(C19*C22*S20p21+S19*S22);
  RL_0_224 = (S19*S20p21*C22-C19*S22)*s.dpt(3,22);
  RL_0_324 = s.dpt(3,22)*C22*C20p21;
  JT_0_124_19 = -(RL_0_221+RL_0_222+RL_0_224);
  JT_0_224_19 = RL_0_121+RL_0_122+RL_0_124;
  JT_0_124_20 = C19*(RL_0_321+RL_0_324);
  JT_0_224_20 = S19*(RL_0_321+RL_0_324);
  JT_0_324_20 = -(RL_0_124*C19+RL_0_224*S19+s.dpt(3,19)*S20);
  JT_0_124_21 = RL_0_324*C19;
  JT_0_224_21 = RL_0_324*S19;
  JT_0_324_21 = -(RL_0_124*C19+RL_0_224*S19);
  JT_0_124_22 = RL_0_224*S20p21+RL_0_324*RO_0_221;
  JT_0_224_22 = -(RL_0_124*S20p21+RL_0_324*RO_0_121);
  JT_0_324_22 = -(RL_0_124*RO_0_221-RL_0_224*RO_0_121);

% = = Block_0_1_0_0_1_0 = = 
 
% Constraints and Constraints Jacobian 

%
  h_1 = RL_0_121+RL_0_122+RL_0_124-RL_1_125-q(1)+s.dpt(1,3)-s.dpt(1,6);
  h_2 = RL_0_221+RL_0_222+RL_0_224-RL_1_225-q(2)+s.dpt(2,3)-s.dpt(2,6);
  h_3 = RL_0_321+RL_0_324-q(3);
%
  h_4 = RL_2_111+RL_2_126-RL_3_127-q(1)+s.dpt(1,1)-s.dpt(1,4);
  h_5 = RL_2_226-RL_3_227-q(2)+s.dpt(2,12);
  h_6 = RL_2_311+RL_2_326-q(3);
%
  h_7 = RL_4_116+RL_4_117+RL_4_128-RL_5_129-q(1)+s.dpt(1,2)-s.dpt(1,5);
  h_8 = RL_4_216+RL_4_217+RL_4_228-RL_5_229-q(2)+s.dpt(2,2)-s.dpt(2,5);
  h_9 = RL_4_316+RL_4_328-q(3);

% = = Block_0_3_0_0_0_0 = = 
 
% Symbolic Outputs  

  h(1) = h_1;
  h(2) = h_2;
  h(3) = h_3;
  h(4) = h_4;
  h(5) = h_5;
  h(6) = h_6;
  h(7) = h_7;
  h(8) = h_8;
  h(9) = h_9;
  Jac(1,1) = -(1.0);
  Jac(1,8) = RL_1_225;
  Jac(1,19) = JT_0_124_19;
  Jac(1,20) = JT_0_124_20;
  Jac(1,21) = JT_0_124_21;
  Jac(1,22) = JT_0_124_22;
  Jac(2,2) = -(1.0);
  Jac(2,8) = -RL_1_125;
  Jac(2,19) = JT_0_224_19;
  Jac(2,20) = JT_0_224_20;
  Jac(2,21) = JT_0_224_21;
  Jac(2,22) = JT_0_224_22;
  Jac(3,3) = -(1.0);
  Jac(3,20) = JT_0_324_20;
  Jac(3,21) = JT_0_324_21;
  Jac(3,22) = JT_0_324_22;
  Jac(4,1) = -(1.0);
  Jac(4,4) = RL_3_227;
  Jac(4,10) = JT_2_126_10;
  Jac(4,11) = RL_2_326;
  Jac(4,12) = JT_2_126_12;
  Jac(5,2) = -(1.0);
  Jac(5,4) = -RL_3_127;
  Jac(5,12) = JT_2_226_12;
  Jac(6,3) = -(1.0);
  Jac(6,10) = JT_2_326_10;
  Jac(6,11) = -RL_2_126;
  Jac(6,12) = JT_2_326_12;
  Jac(7,1) = -(1.0);
  Jac(7,6) = RL_5_229;
  Jac(7,14) = JT_4_128_14;
  Jac(7,15) = JT_4_128_15;
  Jac(7,16) = JT_4_128_16;
  Jac(7,17) = JT_4_128_17;
  Jac(8,2) = -(1.0);
  Jac(8,6) = -RL_5_129;
  Jac(8,14) = JT_4_228_14;
  Jac(8,15) = JT_4_228_15;
  Jac(8,16) = JT_4_228_16;
  Jac(8,17) = JT_4_228_17;
  Jac(9,3) = -(1.0);
  Jac(9,15) = JT_4_328_15;
  Jac(9,16) = JT_4_328_16;
  Jac(9,17) = JT_4_328_17;

% ====== END Task 0 ====== 

  

