%
%-------------------------------------------------------------
%
%	ROBOTRAN - Version 6.6 (build : february 22, 2008)
%
%	Copyright 
%	Universite catholique de Louvain 
%	Departement de Mecanique 
%	Unite de Production Mecanique et Machines 
%	2, Place du Levant 
%	1348 Louvain-la-Neuve 
%	http://www.robotran.be// 
%
%	==> Generation Date : Wed Nov  6 15:34:11 2019
%
%	==> Project name : delta_fisette_matlab
%	==> using XML input file 
%
%	==> Number of joints : 23
%
%	==> Function : F 6 : Sensors Kinematical Informations (sens) 
%	==> Flops complexity : 629
%
%	==> Generation Time :  0.010 seconds
%	==> Post-Processing :  0.020 seconds
%
%-------------------------------------------------------------
%
function [sens] = gensensor(s,tsim,usrfun,isens)

 sens.P = zeros(3,1);
 sens.R = zeros(3,3);
 sens.V = zeros(3,1);
 sens.OM = zeros(3,1);
 sens.A = zeros(3,1);
 sens.OMP = zeros(3,1);
 sens.J = zeros(6,23);

q = s.q; 
qd = s.qd; 
qdd = s.qdd; 
frc = s.frc; 
trq = s.trq; 

% === begin imp_aux === 

% === end imp_aux === 

% ===== BEGIN task 0 ===== 
 
% Sensor Kinematics 



% = = Block_0_0_0_0_0_2 = = 
 
% Trigonometric Variables  

  C4 = cos(q(4));
  S4 = sin(q(4));
  C5 = cos(q(5));
  S5 = sin(q(5));

% = = Block_0_0_0_0_0_3 = = 
 
% Trigonometric Variables  

  C6 = cos(q(6));
  S6 = sin(q(6));
  C7 = cos(q(7));
  S7 = sin(q(7));

% = = Block_0_0_0_0_0_4 = = 
 
% Trigonometric Variables  

  C8 = cos(q(8));
  S8 = sin(q(8));
  C9 = cos(q(9));
  S9 = sin(q(9));

% = = Block_0_0_0_0_0_5 = = 
 
% Trigonometric Variables  

  C10 = cos(q(10));
  S10 = sin(q(10));
  C11 = cos(q(11));
  S11 = sin(q(11));

% = = Block_0_0_0_0_0_6 = = 
 
% Trigonometric Variables  

  C12 = cos(q(12));
  S12 = sin(q(12));

% = = Block_0_0_0_0_0_7 = = 
 
% Trigonometric Variables  

  C13 = cos(q(13));
  S13 = sin(q(13));

% = = Block_0_0_0_0_0_8 = = 
 
% Trigonometric Variables  

  C14 = cos(q(14));
  S14 = sin(q(14));
  C15 = cos(q(15));
  S15 = sin(q(15));
  C16 = cos(q(16));
  S16 = sin(q(16));

% = = Block_0_0_0_0_0_9 = = 
 
% Trigonometric Variables  

  C17 = cos(q(17));
  S17 = sin(q(17));

% = = Block_0_0_0_0_0_10 = = 
 
% Trigonometric Variables  

  C18 = cos(q(18));
  S18 = sin(q(18));

% = = Block_0_0_0_0_0_11 = = 
 
% Trigonometric Variables  

  C19 = cos(q(19));
  S19 = sin(q(19));
  C20 = cos(q(20));
  S20 = sin(q(20));
  C21 = cos(q(21));
  S21 = sin(q(21));

% = = Block_0_0_0_0_0_12 = = 
 
% Trigonometric Variables  

  C22 = cos(q(22));
  S22 = sin(q(22));

% = = Block_0_0_0_0_0_13 = = 
 
% Trigonometric Variables  

  C23 = cos(q(23));
  S23 = sin(q(23));

% = = Block_0_0_0_11_0_5 = = 
 
% Trigonometric Variables  

  S10p11 = C10*S11+S10*C11;
  C10p11 = C10*C11-S10*S11;

% = = Block_0_0_0_16_0_8 = = 
 
% Trigonometric Variables  

  S15p16 = C15*S16+S15*C16;
  C15p16 = C15*C16-S15*S16;

% = = Block_0_0_0_21_0_11 = = 
 
% Trigonometric Variables  

  S20p21 = C20*S21+S20*C21;
  C20p21 = C20*C21-S20*S21;

% ====== END Task 0 ====== 

% ===== BEGIN task 1 ===== 
 
switch isens

 
% 
case 1, 


% = = Block_1_0_0_1_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = q(1);
    sens.R(1,1) = (1.0);
    sens.R(2,2) = (1.0);
    sens.R(3,3) = (1.0);
    sens.V(1) = qd(1);
    sens.A(1) = qdd(1);
 
% 
case 2, 


% = = Block_1_0_0_2_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = q(1);
    sens.P(2) = q(2);
    sens.R(1,1) = (1.0);
    sens.R(2,2) = (1.0);
    sens.R(3,3) = (1.0);
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
 
% 
case 3, 


% = = Block_1_0_0_3_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = q(1);
    sens.P(2) = q(2);
    sens.P(3) = q(3);
    sens.R(1,1) = (1.0);
    sens.R(2,2) = (1.0);
    sens.R(3,3) = (1.0);
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.V(3) = qd(3);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
    sens.A(3) = qdd(3);
 
% 
case 4, 


% = = Block_1_0_0_4_0_2 = = 
 
% Sensor Kinematics 


    POcp3_14 = q(1)+s.dpt(1,4);

% = = Block_1_0_0_4_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp3_14;
    sens.P(2) = q(2);
    sens.P(3) = q(3);
    sens.R(1,1) = C4;
    sens.R(1,2) = S4;
    sens.R(2,1) = -S4;
    sens.R(2,2) = C4;
    sens.R(3,3) = (1.0);
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.V(3) = qd(3);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
    sens.A(3) = qdd(3);
 
% 
case 5, 


% = = Block_1_0_0_5_0_2 = = 
 
% Sensor Kinematics 


    ROcp4_15 = C4*C5;
    ROcp4_25 = S4*C5;
    ROcp4_75 = C4*S5;
    ROcp4_85 = S4*S5;
    POcp4_14 = q(1)+s.dpt(1,4);

% = = Block_1_0_0_5_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp4_14;
    sens.P(2) = q(2);
    sens.P(3) = q(3);
    sens.R(1,1) = ROcp4_15;
    sens.R(1,2) = ROcp4_25;
    sens.R(1,3) = -S5;
    sens.R(2,1) = -S4;
    sens.R(2,2) = C4;
    sens.R(3,1) = ROcp4_75;
    sens.R(3,2) = ROcp4_85;
    sens.R(3,3) = C5;
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.V(3) = qd(3);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
    sens.A(3) = qdd(3);
 
% 
case 6, 


% = = Block_1_0_0_6_0_3 = = 
 
% Sensor Kinematics 


    POcp5_16 = q(1)+s.dpt(1,5);
    POcp5_26 = q(2)+s.dpt(2,5);

% = = Block_1_0_0_6_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp5_16;
    sens.P(2) = POcp5_26;
    sens.P(3) = q(3);
    sens.R(1,1) = C6;
    sens.R(1,2) = S6;
    sens.R(2,1) = -S6;
    sens.R(2,2) = C6;
    sens.R(3,3) = (1.0);
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.V(3) = qd(3);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
    sens.A(3) = qdd(3);
 
% 
case 7, 


% = = Block_1_0_0_7_0_3 = = 
 
% Sensor Kinematics 


    ROcp6_17 = C6*C7;
    ROcp6_27 = S6*C7;
    ROcp6_77 = C6*S7;
    ROcp6_87 = S6*S7;
    POcp6_16 = q(1)+s.dpt(1,5);
    POcp6_26 = q(2)+s.dpt(2,5);

% = = Block_1_0_0_7_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp6_16;
    sens.P(2) = POcp6_26;
    sens.P(3) = q(3);
    sens.R(1,1) = ROcp6_17;
    sens.R(1,2) = ROcp6_27;
    sens.R(1,3) = -S7;
    sens.R(2,1) = -S6;
    sens.R(2,2) = C6;
    sens.R(3,1) = ROcp6_77;
    sens.R(3,2) = ROcp6_87;
    sens.R(3,3) = C7;
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.V(3) = qd(3);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
    sens.A(3) = qdd(3);
 
% 
case 8, 


% = = Block_1_0_0_8_0_4 = = 
 
% Sensor Kinematics 


    POcp7_18 = q(1)+s.dpt(1,6);
    POcp7_28 = q(2)+s.dpt(2,6);

% = = Block_1_0_0_8_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp7_18;
    sens.P(2) = POcp7_28;
    sens.P(3) = q(3);
    sens.R(1,1) = C8;
    sens.R(1,2) = S8;
    sens.R(2,1) = -S8;
    sens.R(2,2) = C8;
    sens.R(3,3) = (1.0);
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.V(3) = qd(3);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
    sens.A(3) = qdd(3);
 
% 
case 9, 


% = = Block_1_0_0_9_0_4 = = 
 
% Sensor Kinematics 


    ROcp8_19 = C8*C9;
    ROcp8_29 = S8*C9;
    ROcp8_79 = C8*S9;
    ROcp8_89 = S8*S9;
    POcp8_18 = q(1)+s.dpt(1,6);
    POcp8_28 = q(2)+s.dpt(2,6);

% = = Block_1_0_0_9_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp8_18;
    sens.P(2) = POcp8_28;
    sens.P(3) = q(3);
    sens.R(1,1) = ROcp8_19;
    sens.R(1,2) = ROcp8_29;
    sens.R(1,3) = -S9;
    sens.R(2,1) = -S8;
    sens.R(2,2) = C8;
    sens.R(3,1) = ROcp8_79;
    sens.R(3,2) = ROcp8_89;
    sens.R(3,3) = C9;
    sens.V(1) = qd(1);
    sens.V(2) = qd(2);
    sens.V(3) = qd(3);
    sens.A(1) = qdd(1);
    sens.A(2) = qdd(2);
    sens.A(3) = qdd(3);
 
% 
case 10, 


% = = Block_1_0_0_10_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = s.dpt(1,1);
    sens.R(1,1) = C10;
    sens.R(1,3) = -S10;
    sens.R(2,2) = (1.0);
    sens.R(3,1) = S10;
    sens.R(3,3) = C10;
    sens.OM(2) = qd(10);
    sens.OMP(2) = qdd(10);
 
% 
case 11, 


% = = Block_1_0_0_11_0_5 = = 
 
% Sensor Kinematics 


    RLcp10_111 = s.dpt(3,11)*S10;
    RLcp10_311 = s.dpt(3,11)*C10;
    POcp10_111 = RLcp10_111+s.dpt(1,1);
    OMcp10_211 = qd(10)+qd(11);
    ORcp10_111 = RLcp10_311*qd(10);
    ORcp10_311 = -RLcp10_111*qd(10);
    OPcp10_211 = qdd(10)+qdd(11);
    ACcp10_111 = ORcp10_311*qd(10)+RLcp10_311*qdd(10);
    ACcp10_311 = -(ORcp10_111*qd(10)+RLcp10_111*qdd(10));

% = = Block_1_0_0_11_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp10_111;
    sens.P(3) = RLcp10_311;
    sens.R(1,1) = C10p11;
    sens.R(1,3) = -S10p11;
    sens.R(2,2) = (1.0);
    sens.R(3,1) = S10p11;
    sens.R(3,3) = C10p11;
    sens.V(1) = ORcp10_111;
    sens.V(3) = ORcp10_311;
    sens.OM(2) = OMcp10_211;
    sens.A(1) = ACcp10_111;
    sens.A(3) = ACcp10_311;
    sens.OMP(2) = OPcp10_211;
 
% 
case 12, 


% = = Block_1_0_0_12_0_5 = = 
 
% Sensor Kinematics 


    RLcp11_111 = s.dpt(3,11)*S10;
    RLcp11_311 = s.dpt(3,11)*C10;
    POcp11_111 = RLcp11_111+s.dpt(1,1);
    OMcp11_211 = qd(10)+qd(11);
    ORcp11_111 = RLcp11_311*qd(10);
    ORcp11_311 = -RLcp11_111*qd(10);
    OPcp11_211 = qdd(10)+qdd(11);
    ACcp11_111 = ORcp11_311*qd(10)+RLcp11_311*qdd(10);
    ACcp11_311 = -(ORcp11_111*qd(10)+RLcp11_111*qdd(10));

% = = Block_1_0_0_12_0_6 = = 
 
% Sensor Kinematics 


    ROcp11_412 = S12*S10p11;
    ROcp11_612 = S12*C10p11;
    ROcp11_712 = C12*S10p11;
    ROcp11_912 = C12*C10p11;
    OMcp11_112 = qd(12)*C10p11;
    OMcp11_312 = -qd(12)*S10p11;
    OPcp11_112 = -(OMcp11_211*qd(12)*S10p11-qdd(12)*C10p11);
    OPcp11_312 = -(OMcp11_211*qd(12)*C10p11+qdd(12)*S10p11);

% = = Block_1_0_0_12_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp11_111;
    sens.P(2) = s.dpt(2,12);
    sens.P(3) = RLcp11_311;
    sens.R(1,1) = C10p11;
    sens.R(1,3) = -S10p11;
    sens.R(2,1) = ROcp11_412;
    sens.R(2,2) = C12;
    sens.R(2,3) = ROcp11_612;
    sens.R(3,1) = ROcp11_712;
    sens.R(3,2) = -S12;
    sens.R(3,3) = ROcp11_912;
    sens.V(1) = ORcp11_111;
    sens.V(3) = ORcp11_311;
    sens.OM(1) = OMcp11_112;
    sens.OM(2) = OMcp11_211;
    sens.OM(3) = OMcp11_312;
    sens.A(1) = ACcp11_111;
    sens.A(3) = ACcp11_311;
    sens.OMP(1) = OPcp11_112;
    sens.OMP(2) = OPcp11_211;
    sens.OMP(3) = OPcp11_312;
 
% 
case 13, 


% = = Block_1_0_0_13_0_5 = = 
 
% Sensor Kinematics 


    RLcp12_111 = s.dpt(3,11)*S10;
    RLcp12_311 = s.dpt(3,11)*C10;
    POcp12_111 = RLcp12_111+s.dpt(1,1);
    OMcp12_211 = qd(10)+qd(11);
    ORcp12_111 = RLcp12_311*qd(10);
    ORcp12_311 = -RLcp12_111*qd(10);
    OPcp12_211 = qdd(10)+qdd(11);
    ACcp12_111 = ORcp12_311*qd(10)+RLcp12_311*qdd(10);
    ACcp12_311 = -(ORcp12_111*qd(10)+RLcp12_111*qdd(10));

% = = Block_1_0_0_13_0_7 = = 
 
% Sensor Kinematics 


    ROcp12_413 = S13*S10p11;
    ROcp12_613 = S13*C10p11;
    ROcp12_713 = C13*S10p11;
    ROcp12_913 = C13*C10p11;
    OMcp12_113 = qd(13)*C10p11;
    OMcp12_313 = -qd(13)*S10p11;
    OPcp12_113 = -(OMcp12_211*qd(13)*S10p11-qdd(13)*C10p11);
    OPcp12_313 = -(OMcp12_211*qd(13)*C10p11+qdd(13)*S10p11);

% = = Block_1_0_0_13_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp12_111;
    sens.P(2) = s.dpt(2,13);
    sens.P(3) = RLcp12_311;
    sens.R(1,1) = C10p11;
    sens.R(1,3) = -S10p11;
    sens.R(2,1) = ROcp12_413;
    sens.R(2,2) = C13;
    sens.R(2,3) = ROcp12_613;
    sens.R(3,1) = ROcp12_713;
    sens.R(3,2) = -S13;
    sens.R(3,3) = ROcp12_913;
    sens.V(1) = ORcp12_111;
    sens.V(3) = ORcp12_311;
    sens.OM(1) = OMcp12_113;
    sens.OM(2) = OMcp12_211;
    sens.OM(3) = OMcp12_313;
    sens.A(1) = ACcp12_111;
    sens.A(3) = ACcp12_311;
    sens.OMP(1) = OPcp12_113;
    sens.OMP(2) = OPcp12_211;
    sens.OMP(3) = OPcp12_313;
 
% 
case 14, 


% = = Block_1_0_0_14_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = s.dpt(1,2);
    sens.P(2) = s.dpt(2,2);
    sens.R(1,1) = C14;
    sens.R(1,2) = S14;
    sens.R(2,1) = -S14;
    sens.R(2,2) = C14;
    sens.R(3,3) = (1.0);
 
% 
case 15, 


% = = Block_1_0_0_15_0_8 = = 
 
% Sensor Kinematics 


    ROcp14_115 = C14*C15;
    ROcp14_215 = S14*C15;
    ROcp14_715 = C14*S15;
    ROcp14_815 = S14*S15;
    OMcp14_115 = -qd(15)*S14;
    OMcp14_215 = qd(15)*C14;
    OPcp14_115 = -qdd(15)*S14;
    OPcp14_215 = qdd(15)*C14;

% = = Block_1_0_0_15_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = s.dpt(1,2);
    sens.P(2) = s.dpt(2,2);
    sens.R(1,1) = ROcp14_115;
    sens.R(1,2) = ROcp14_215;
    sens.R(1,3) = -S15;
    sens.R(2,1) = -S14;
    sens.R(2,2) = C14;
    sens.R(3,1) = ROcp14_715;
    sens.R(3,2) = ROcp14_815;
    sens.R(3,3) = C15;
    sens.OM(1) = OMcp14_115;
    sens.OM(2) = OMcp14_215;
    sens.OMP(1) = OPcp14_115;
    sens.OMP(2) = OPcp14_215;
 
% 
case 16, 


% = = Block_1_0_0_16_0_8 = = 
 
% Sensor Kinematics 


    ROcp15_116 = C14*C15p16;
    ROcp15_216 = S14*C15p16;
    ROcp15_716 = C14*S15p16;
    ROcp15_816 = S14*S15p16;
    OMcp15_115 = -qd(15)*S14;
    OMcp15_215 = qd(15)*C14;
    OPcp15_115 = -qdd(15)*S14;
    OPcp15_215 = qdd(15)*C14;
    RLcp15_116 = s.dpt(3,15)*C14*S15;
    RLcp15_216 = s.dpt(3,15)*S14*S15;
    RLcp15_316 = s.dpt(3,15)*C15;
    POcp15_116 = RLcp15_116+s.dpt(1,2);
    POcp15_216 = RLcp15_216+s.dpt(2,2);
    OMcp15_116 = OMcp15_115-qd(16)*S14;
    OMcp15_216 = C14*(qd(15)+qd(16));
    ORcp15_116 = OMcp15_215*RLcp15_316;
    ORcp15_216 = -OMcp15_115*RLcp15_316;
    ORcp15_316 = -qd(15)*s.dpt(3,15)*S15;
    OPcp15_116 = OPcp15_115-qdd(16)*S14;
    OPcp15_216 = C14*(qdd(15)+qdd(16));
    ACcp15_116 = OMcp15_215*ORcp15_316+OPcp15_215*RLcp15_316;
    ACcp15_216 = -(OMcp15_115*ORcp15_316+OPcp15_115*RLcp15_316);
    ACcp15_316 = OMcp15_115*ORcp15_216-OMcp15_215*ORcp15_116+OPcp15_115*RLcp15_216-OPcp15_215*RLcp15_116;

% = = Block_1_0_0_16_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp15_116;
    sens.P(2) = POcp15_216;
    sens.P(3) = RLcp15_316;
    sens.R(1,1) = ROcp15_116;
    sens.R(1,2) = ROcp15_216;
    sens.R(1,3) = -S15p16;
    sens.R(2,1) = -S14;
    sens.R(2,2) = C14;
    sens.R(3,1) = ROcp15_716;
    sens.R(3,2) = ROcp15_816;
    sens.R(3,3) = C15p16;
    sens.V(1) = ORcp15_116;
    sens.V(2) = ORcp15_216;
    sens.V(3) = ORcp15_316;
    sens.OM(1) = OMcp15_116;
    sens.OM(2) = OMcp15_216;
    sens.A(1) = ACcp15_116;
    sens.A(2) = ACcp15_216;
    sens.A(3) = ACcp15_316;
    sens.OMP(1) = OPcp15_116;
    sens.OMP(2) = OPcp15_216;
 
% 
case 17, 


% = = Block_1_0_0_17_0_8 = = 
 
% Sensor Kinematics 


    ROcp16_116 = C14*C15p16;
    ROcp16_216 = S14*C15p16;
    ROcp16_716 = C14*S15p16;
    ROcp16_816 = S14*S15p16;
    OMcp16_115 = -qd(15)*S14;
    OMcp16_215 = qd(15)*C14;
    OPcp16_115 = -qdd(15)*S14;
    OPcp16_215 = qdd(15)*C14;
    RLcp16_116 = s.dpt(3,15)*C14*S15;
    RLcp16_216 = s.dpt(3,15)*S14*S15;
    RLcp16_316 = s.dpt(3,15)*C15;
    OMcp16_116 = OMcp16_115-qd(16)*S14;
    OMcp16_216 = C14*(qd(15)+qd(16));
    ORcp16_116 = OMcp16_215*RLcp16_316;
    ORcp16_216 = -OMcp16_115*RLcp16_316;
    ORcp16_316 = -qd(15)*s.dpt(3,15)*S15;
    OPcp16_116 = OPcp16_115-qdd(16)*S14;
    OPcp16_216 = C14*(qdd(15)+qdd(16));
    ACcp16_116 = OMcp16_215*ORcp16_316+OPcp16_215*RLcp16_316;
    ACcp16_216 = -(OMcp16_115*ORcp16_316+OPcp16_115*RLcp16_316);

% = = Block_1_0_0_17_0_9 = = 
 
% Sensor Kinematics 


    ROcp16_417 = ROcp16_716*S17-S14*C17;
    ROcp16_517 = ROcp16_816*S17+C14*C17;
    ROcp16_617 = S17*C15p16;
    ROcp16_717 = ROcp16_716*C17+S14*S17;
    ROcp16_817 = ROcp16_816*C17-C14*S17;
    ROcp16_917 = C17*C15p16;
    RLcp16_117 = -s.dpt(2,16)*S14;
    RLcp16_217 = s.dpt(2,16)*C14;
    POcp16_117 = RLcp16_116+RLcp16_117+s.dpt(1,2);
    POcp16_217 = RLcp16_216+RLcp16_217+s.dpt(2,2);
    OMcp16_117 = OMcp16_116+ROcp16_116*qd(17);
    OMcp16_217 = OMcp16_216+ROcp16_216*qd(17);
    OMcp16_317 = -qd(17)*S15p16;
    OPcp16_117 = OPcp16_116-OMcp16_216*qd(17)*S15p16+ROcp16_116*qdd(17);
    OPcp16_217 = OPcp16_216+OMcp16_116*qd(17)*S15p16+ROcp16_216*qdd(17);
    OPcp16_317 = -(qdd(17)*S15p16+qd(17)*C15p16*(qd(15)+qd(16)));
    ACcp16_317 = OMcp16_115*ORcp16_216-OMcp16_215*ORcp16_116+OPcp16_115*RLcp16_216+OPcp16_116*RLcp16_217-OPcp16_215*RLcp16_116-OPcp16_216*...
 RLcp16_117;

% = = Block_1_0_0_17_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp16_117;
    sens.P(2) = POcp16_217;
    sens.P(3) = RLcp16_316;
    sens.R(1,1) = ROcp16_116;
    sens.R(1,2) = ROcp16_216;
    sens.R(1,3) = -S15p16;
    sens.R(2,1) = ROcp16_417;
    sens.R(2,2) = ROcp16_517;
    sens.R(2,3) = ROcp16_617;
    sens.R(3,1) = ROcp16_717;
    sens.R(3,2) = ROcp16_817;
    sens.R(3,3) = ROcp16_917;
    sens.V(1) = ORcp16_116;
    sens.V(2) = ORcp16_216;
    sens.V(3) = ORcp16_316;
    sens.OM(1) = OMcp16_117;
    sens.OM(2) = OMcp16_217;
    sens.OM(3) = OMcp16_317;
    sens.A(1) = ACcp16_116;
    sens.A(2) = ACcp16_216;
    sens.A(3) = ACcp16_317;
    sens.OMP(1) = OPcp16_117;
    sens.OMP(2) = OPcp16_217;
    sens.OMP(3) = OPcp16_317;
 
% 
case 18, 


% = = Block_1_0_0_18_0_8 = = 
 
% Sensor Kinematics 


    ROcp17_116 = C14*C15p16;
    ROcp17_216 = S14*C15p16;
    ROcp17_716 = C14*S15p16;
    ROcp17_816 = S14*S15p16;
    OMcp17_115 = -qd(15)*S14;
    OMcp17_215 = qd(15)*C14;
    OPcp17_115 = -qdd(15)*S14;
    OPcp17_215 = qdd(15)*C14;
    RLcp17_116 = s.dpt(3,15)*C14*S15;
    RLcp17_216 = s.dpt(3,15)*S14*S15;
    RLcp17_316 = s.dpt(3,15)*C15;
    OMcp17_116 = OMcp17_115-qd(16)*S14;
    OMcp17_216 = C14*(qd(15)+qd(16));
    ORcp17_116 = OMcp17_215*RLcp17_316;
    ORcp17_216 = -OMcp17_115*RLcp17_316;
    ORcp17_316 = -qd(15)*s.dpt(3,15)*S15;
    OPcp17_116 = OPcp17_115-qdd(16)*S14;
    OPcp17_216 = C14*(qdd(15)+qdd(16));
    ACcp17_116 = OMcp17_215*ORcp17_316+OPcp17_215*RLcp17_316;
    ACcp17_216 = -(OMcp17_115*ORcp17_316+OPcp17_115*RLcp17_316);

% = = Block_1_0_0_18_0_10 = = 
 
% Sensor Kinematics 


    ROcp17_418 = ROcp17_716*S18-S14*C18;
    ROcp17_518 = ROcp17_816*S18+C14*C18;
    ROcp17_618 = S18*C15p16;
    ROcp17_718 = ROcp17_716*C18+S14*S18;
    ROcp17_818 = ROcp17_816*C18-C14*S18;
    ROcp17_918 = C18*C15p16;
    RLcp17_118 = -s.dpt(2,17)*S14;
    RLcp17_218 = s.dpt(2,17)*C14;
    POcp17_118 = RLcp17_116+RLcp17_118+s.dpt(1,2);
    POcp17_218 = RLcp17_216+RLcp17_218+s.dpt(2,2);
    OMcp17_118 = OMcp17_116+ROcp17_116*qd(18);
    OMcp17_218 = OMcp17_216+ROcp17_216*qd(18);
    OMcp17_318 = -qd(18)*S15p16;
    OPcp17_118 = OPcp17_116-OMcp17_216*qd(18)*S15p16+ROcp17_116*qdd(18);
    OPcp17_218 = OPcp17_216+OMcp17_116*qd(18)*S15p16+ROcp17_216*qdd(18);
    OPcp17_318 = -(qdd(18)*S15p16+qd(18)*C15p16*(qd(15)+qd(16)));
    ACcp17_318 = OMcp17_115*ORcp17_216-OMcp17_215*ORcp17_116+OPcp17_115*RLcp17_216+OPcp17_116*RLcp17_218-OPcp17_215*RLcp17_116-OPcp17_216*...
 RLcp17_118;

% = = Block_1_0_0_18_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp17_118;
    sens.P(2) = POcp17_218;
    sens.P(3) = RLcp17_316;
    sens.R(1,1) = ROcp17_116;
    sens.R(1,2) = ROcp17_216;
    sens.R(1,3) = -S15p16;
    sens.R(2,1) = ROcp17_418;
    sens.R(2,2) = ROcp17_518;
    sens.R(2,3) = ROcp17_618;
    sens.R(3,1) = ROcp17_718;
    sens.R(3,2) = ROcp17_818;
    sens.R(3,3) = ROcp17_918;
    sens.V(1) = ORcp17_116;
    sens.V(2) = ORcp17_216;
    sens.V(3) = ORcp17_316;
    sens.OM(1) = OMcp17_118;
    sens.OM(2) = OMcp17_218;
    sens.OM(3) = OMcp17_318;
    sens.A(1) = ACcp17_116;
    sens.A(2) = ACcp17_216;
    sens.A(3) = ACcp17_318;
    sens.OMP(1) = OPcp17_118;
    sens.OMP(2) = OPcp17_218;
    sens.OMP(3) = OPcp17_318;
 
% 
case 19, 


% = = Block_1_0_0_19_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = s.dpt(1,3);
    sens.P(2) = s.dpt(2,3);
    sens.R(1,1) = C19;
    sens.R(1,2) = S19;
    sens.R(2,1) = -S19;
    sens.R(2,2) = C19;
    sens.R(3,3) = (1.0);
 
% 
case 20, 


% = = Block_1_0_0_20_0_11 = = 
 
% Sensor Kinematics 


    ROcp19_120 = C19*C20;
    ROcp19_220 = S19*C20;
    ROcp19_720 = C19*S20;
    ROcp19_820 = S19*S20;
    OMcp19_120 = -qd(20)*S19;
    OMcp19_220 = qd(20)*C19;
    OPcp19_120 = -qdd(20)*S19;
    OPcp19_220 = qdd(20)*C19;

% = = Block_1_0_0_20_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = s.dpt(1,3);
    sens.P(2) = s.dpt(2,3);
    sens.R(1,1) = ROcp19_120;
    sens.R(1,2) = ROcp19_220;
    sens.R(1,3) = -S20;
    sens.R(2,1) = -S19;
    sens.R(2,2) = C19;
    sens.R(3,1) = ROcp19_720;
    sens.R(3,2) = ROcp19_820;
    sens.R(3,3) = C20;
    sens.OM(1) = OMcp19_120;
    sens.OM(2) = OMcp19_220;
    sens.OMP(1) = OPcp19_120;
    sens.OMP(2) = OPcp19_220;
 
% 
case 21, 


% = = Block_1_0_0_21_0_11 = = 
 
% Sensor Kinematics 


    ROcp20_121 = C19*C20p21;
    ROcp20_221 = S19*C20p21;
    ROcp20_721 = C19*S20p21;
    ROcp20_821 = S19*S20p21;
    OMcp20_120 = -qd(20)*S19;
    OMcp20_220 = qd(20)*C19;
    OPcp20_120 = -qdd(20)*S19;
    OPcp20_220 = qdd(20)*C19;
    RLcp20_121 = s.dpt(3,19)*C19*S20;
    RLcp20_221 = s.dpt(3,19)*S19*S20;
    RLcp20_321 = s.dpt(3,19)*C20;
    POcp20_121 = RLcp20_121+s.dpt(1,3);
    POcp20_221 = RLcp20_221+s.dpt(2,3);
    OMcp20_121 = OMcp20_120-qd(21)*S19;
    OMcp20_221 = C19*(qd(20)+qd(21));
    ORcp20_121 = OMcp20_220*RLcp20_321;
    ORcp20_221 = -OMcp20_120*RLcp20_321;
    ORcp20_321 = -qd(20)*s.dpt(3,19)*S20;
    OPcp20_121 = OPcp20_120-qdd(21)*S19;
    OPcp20_221 = C19*(qdd(20)+qdd(21));
    ACcp20_121 = OMcp20_220*ORcp20_321+OPcp20_220*RLcp20_321;
    ACcp20_221 = -(OMcp20_120*ORcp20_321+OPcp20_120*RLcp20_321);
    ACcp20_321 = OMcp20_120*ORcp20_221-OMcp20_220*ORcp20_121+OPcp20_120*RLcp20_221-OPcp20_220*RLcp20_121;

% = = Block_1_0_0_21_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp20_121;
    sens.P(2) = POcp20_221;
    sens.P(3) = RLcp20_321;
    sens.R(1,1) = ROcp20_121;
    sens.R(1,2) = ROcp20_221;
    sens.R(1,3) = -S20p21;
    sens.R(2,1) = -S19;
    sens.R(2,2) = C19;
    sens.R(3,1) = ROcp20_721;
    sens.R(3,2) = ROcp20_821;
    sens.R(3,3) = C20p21;
    sens.V(1) = ORcp20_121;
    sens.V(2) = ORcp20_221;
    sens.V(3) = ORcp20_321;
    sens.OM(1) = OMcp20_121;
    sens.OM(2) = OMcp20_221;
    sens.A(1) = ACcp20_121;
    sens.A(2) = ACcp20_221;
    sens.A(3) = ACcp20_321;
    sens.OMP(1) = OPcp20_121;
    sens.OMP(2) = OPcp20_221;
 
% 
case 22, 


% = = Block_1_0_0_22_0_11 = = 
 
% Sensor Kinematics 


    ROcp21_121 = C19*C20p21;
    ROcp21_221 = S19*C20p21;
    ROcp21_721 = C19*S20p21;
    ROcp21_821 = S19*S20p21;
    OMcp21_120 = -qd(20)*S19;
    OMcp21_220 = qd(20)*C19;
    OPcp21_120 = -qdd(20)*S19;
    OPcp21_220 = qdd(20)*C19;
    RLcp21_121 = s.dpt(3,19)*C19*S20;
    RLcp21_221 = s.dpt(3,19)*S19*S20;
    RLcp21_321 = s.dpt(3,19)*C20;
    OMcp21_121 = OMcp21_120-qd(21)*S19;
    OMcp21_221 = C19*(qd(20)+qd(21));
    ORcp21_121 = OMcp21_220*RLcp21_321;
    ORcp21_221 = -OMcp21_120*RLcp21_321;
    ORcp21_321 = -qd(20)*s.dpt(3,19)*S20;
    OPcp21_121 = OPcp21_120-qdd(21)*S19;
    OPcp21_221 = C19*(qdd(20)+qdd(21));
    ACcp21_121 = OMcp21_220*ORcp21_321+OPcp21_220*RLcp21_321;
    ACcp21_221 = -(OMcp21_120*ORcp21_321+OPcp21_120*RLcp21_321);

% = = Block_1_0_0_22_0_12 = = 
 
% Sensor Kinematics 


    ROcp21_422 = ROcp21_721*S22-S19*C22;
    ROcp21_522 = ROcp21_821*S22+C19*C22;
    ROcp21_622 = S22*C20p21;
    ROcp21_722 = ROcp21_721*C22+S19*S22;
    ROcp21_822 = ROcp21_821*C22-C19*S22;
    ROcp21_922 = C22*C20p21;
    RLcp21_122 = -s.dpt(2,20)*S19;
    RLcp21_222 = s.dpt(2,20)*C19;
    POcp21_122 = RLcp21_121+RLcp21_122+s.dpt(1,3);
    POcp21_222 = RLcp21_221+RLcp21_222+s.dpt(2,3);
    OMcp21_122 = OMcp21_121+ROcp21_121*qd(22);
    OMcp21_222 = OMcp21_221+ROcp21_221*qd(22);
    OMcp21_322 = -qd(22)*S20p21;
    OPcp21_122 = OPcp21_121-OMcp21_221*qd(22)*S20p21+ROcp21_121*qdd(22);
    OPcp21_222 = OPcp21_221+OMcp21_121*qd(22)*S20p21+ROcp21_221*qdd(22);
    OPcp21_322 = -(qdd(22)*S20p21+qd(22)*C20p21*(qd(20)+qd(21)));
    ACcp21_322 = OMcp21_120*ORcp21_221-OMcp21_220*ORcp21_121+OPcp21_120*RLcp21_221+OPcp21_121*RLcp21_222-OPcp21_220*RLcp21_121-OPcp21_221*...
 RLcp21_122;

% = = Block_1_0_0_22_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp21_122;
    sens.P(2) = POcp21_222;
    sens.P(3) = RLcp21_321;
    sens.R(1,1) = ROcp21_121;
    sens.R(1,2) = ROcp21_221;
    sens.R(1,3) = -S20p21;
    sens.R(2,1) = ROcp21_422;
    sens.R(2,2) = ROcp21_522;
    sens.R(2,3) = ROcp21_622;
    sens.R(3,1) = ROcp21_722;
    sens.R(3,2) = ROcp21_822;
    sens.R(3,3) = ROcp21_922;
    sens.V(1) = ORcp21_121;
    sens.V(2) = ORcp21_221;
    sens.V(3) = ORcp21_321;
    sens.OM(1) = OMcp21_122;
    sens.OM(2) = OMcp21_222;
    sens.OM(3) = OMcp21_322;
    sens.A(1) = ACcp21_121;
    sens.A(2) = ACcp21_221;
    sens.A(3) = ACcp21_322;
    sens.OMP(1) = OPcp21_122;
    sens.OMP(2) = OPcp21_222;
    sens.OMP(3) = OPcp21_322;
 
% 
case 23, 


% = = Block_1_0_0_23_0_11 = = 
 
% Sensor Kinematics 


    ROcp22_121 = C19*C20p21;
    ROcp22_221 = S19*C20p21;
    ROcp22_721 = C19*S20p21;
    ROcp22_821 = S19*S20p21;
    OMcp22_120 = -qd(20)*S19;
    OMcp22_220 = qd(20)*C19;
    OPcp22_120 = -qdd(20)*S19;
    OPcp22_220 = qdd(20)*C19;
    RLcp22_121 = s.dpt(3,19)*C19*S20;
    RLcp22_221 = s.dpt(3,19)*S19*S20;
    RLcp22_321 = s.dpt(3,19)*C20;
    OMcp22_121 = OMcp22_120-qd(21)*S19;
    OMcp22_221 = C19*(qd(20)+qd(21));
    ORcp22_121 = OMcp22_220*RLcp22_321;
    ORcp22_221 = -OMcp22_120*RLcp22_321;
    ORcp22_321 = -qd(20)*s.dpt(3,19)*S20;
    OPcp22_121 = OPcp22_120-qdd(21)*S19;
    OPcp22_221 = C19*(qdd(20)+qdd(21));
    ACcp22_121 = OMcp22_220*ORcp22_321+OPcp22_220*RLcp22_321;
    ACcp22_221 = -(OMcp22_120*ORcp22_321+OPcp22_120*RLcp22_321);

% = = Block_1_0_0_23_0_13 = = 
 
% Sensor Kinematics 


    ROcp22_423 = ROcp22_721*S23-S19*C23;
    ROcp22_523 = ROcp22_821*S23+C19*C23;
    ROcp22_623 = S23*C20p21;
    ROcp22_723 = ROcp22_721*C23+S19*S23;
    ROcp22_823 = ROcp22_821*C23-C19*S23;
    ROcp22_923 = C23*C20p21;
    RLcp22_123 = -s.dpt(2,21)*S19;
    RLcp22_223 = s.dpt(2,21)*C19;
    POcp22_123 = RLcp22_121+RLcp22_123+s.dpt(1,3);
    POcp22_223 = RLcp22_221+RLcp22_223+s.dpt(2,3);
    OMcp22_123 = OMcp22_121+ROcp22_121*qd(23);
    OMcp22_223 = OMcp22_221+ROcp22_221*qd(23);
    OMcp22_323 = -qd(23)*S20p21;
    OPcp22_123 = OPcp22_121-OMcp22_221*qd(23)*S20p21+ROcp22_121*qdd(23);
    OPcp22_223 = OPcp22_221+OMcp22_121*qd(23)*S20p21+ROcp22_221*qdd(23);
    OPcp22_323 = -(qdd(23)*S20p21+qd(23)*C20p21*(qd(20)+qd(21)));
    ACcp22_323 = OMcp22_120*ORcp22_221-OMcp22_220*ORcp22_121+OPcp22_120*RLcp22_221+OPcp22_121*RLcp22_223-OPcp22_220*RLcp22_121-OPcp22_221*...
 RLcp22_123;

% = = Block_1_0_0_23_1_0 = = 
 
% Symbolic Outputs  

    sens.P(1) = POcp22_123;
    sens.P(2) = POcp22_223;
    sens.P(3) = RLcp22_321;
    sens.R(1,1) = ROcp22_121;
    sens.R(1,2) = ROcp22_221;
    sens.R(1,3) = -S20p21;
    sens.R(2,1) = ROcp22_423;
    sens.R(2,2) = ROcp22_523;
    sens.R(2,3) = ROcp22_623;
    sens.R(3,1) = ROcp22_723;
    sens.R(3,2) = ROcp22_823;
    sens.R(3,3) = ROcp22_923;
    sens.V(1) = ORcp22_121;
    sens.V(2) = ORcp22_221;
    sens.V(3) = ORcp22_321;
    sens.OM(1) = OMcp22_123;
    sens.OM(2) = OMcp22_223;
    sens.OM(3) = OMcp22_323;
    sens.A(1) = ACcp22_121;
    sens.A(2) = ACcp22_221;
    sens.A(3) = ACcp22_323;
    sens.OMP(1) = OPcp22_123;
    sens.OMP(2) = OPcp22_223;
    sens.OMP(3) = OPcp22_323;

end


% ====== END Task 1 ====== 

  

