#
#-------------------------------------------------------------
#
#	ROBOTRAN - Version 6.6 (build : february 22, 2008)
#
#	Copyright 
#	Universite catholique de Louvain 
#	Departement de Mecanique 
#	Unite de Production Mecanique et Machines 
#	2, Place du Levant 
#	1348 Louvain-la-Neuve 
#	http://www.robotran.be// 
#
#	==> Generation Date : Mon Jan 27 13:45:23 2020
#
#	==> Project name : delta_fisette_python
#	==> using XML input file 
#
#	==> Number of joints : 23
#
#	==> Function : F18 : Constraints Quadratic Velocity Terms (Jdqd)
#	==> Flops complexity : 253
#
#	==> Generation Time :  0.010 seconds
#	==> Post-Processing :  0.000 seconds
#
#-------------------------------------------------------------
#
import numpy as np  

def cons_jdqd(Jdqd,s):   
  q = s.q
  qd = s.qd
  qdd = s.qdd

# === begin imp_aux === 

# === end imp_aux === 

# ===== BEGIN task 0 ===== 

# = = Block_0_0_0_0_0_5 = = 
 
# Trigonometric Variables  

  C10 = np.cos(q[10])
  S10 = np.sin(q[10])
  C11 = np.cos(q[11])
  S11 = np.sin(q[11])

# = = Block_0_0_0_0_0_6 = = 
 
# Trigonometric Variables  

  C12 = np.cos(q[12])
  S12 = np.sin(q[12])

# = = Block_0_0_0_0_0_8 = = 
 
# Trigonometric Variables  

  C14 = np.cos(q[14])
  S14 = np.sin(q[14])
  C15 = np.cos(q[15])
  S15 = np.sin(q[15])
  C16 = np.cos(q[16])
  S16 = np.sin(q[16])

# = = Block_0_0_0_0_0_9 = = 
 
# Trigonometric Variables  

  C17 = np.cos(q[17])
  S17 = np.sin(q[17])

# = = Block_0_0_0_0_0_11 = = 
 
# Trigonometric Variables  

  C19 = np.cos(q[19])
  S19 = np.sin(q[19])
  C20 = np.cos(q[20])
  S20 = np.sin(q[20])
  C21 = np.cos(q[21])
  S21 = np.sin(q[21])

# = = Block_0_0_0_0_0_12 = = 
 
# Trigonometric Variables  

  C22 = np.cos(q[22])
  S22 = np.sin(q[22])

# = = Block_0_1_0_0_0_5 = = 
 
# Trigonometric Variables  

#
  S10p11 = C10*S11+S10*C11
  C10p11 = C10*C11-S10*S11

# = = Block_0_1_0_0_0_6 = = 
 
# Constraints and Constraints Jacobian 

#
  RL_2_126 = s.dpt[3,14]*S10p11*C12
  RL_2_226 = -s.dpt[3,14]*S12
  RL_2_326 = s.dpt[3,14]*C10p11*C12

# = = Block_0_1_0_0_0_8 = = 
 
# Trigonometric Variables  

#
  S15p16 = C15*S16+S15*C16
  C15p16 = C15*C16-S15*S16
 
# Constraints and Constraints Jacobian 

  RL_4_316 = s.dpt[3,15]*C15

# = = Block_0_1_0_0_0_9 = = 
 
# Constraints and Constraints Jacobian 

#
  RL_4_128 = s.dpt[3,18]*(S15p16*C14*C17+S14*S17)
  RL_4_228 = s.dpt[3,18]*(S15p16*S14*C17-C14*S17)
  RL_4_328 = s.dpt[3,18]*C15p16*C17

# = = Block_0_1_0_0_0_11 = = 
 
# Trigonometric Variables  

#
  S20p21 = C20*S21+S20*C21
  C20p21 = C20*C21-S20*S21
 
# Constraints and Constraints Jacobian 

  RL_0_321 = s.dpt[3,19]*C20

# = = Block_0_1_0_0_0_12 = = 
 
# Constraints and Constraints Jacobian 

#
  RL_0_124 = s.dpt[3,22]*(S20p21*C19*C22+S19*S22)
  RL_0_224 = s.dpt[3,22]*(S20p21*S19*C22-C19*S22)
  RL_0_324 = s.dpt[3,22]*C20p21*C22

# = = Block_0_2_0_0_0_0 = = 
 
# Constraints Quadratic Terms 

#
  OM_0_120 = -qd[20]*S19
  OM_0_220 = qd[20]*C19
  OM_0_121 = OM_0_120-qd[21]*S19
  OM_0_221 = C19*(qd[20]+qd[21])
  OR_0_321 = -qd[20]*s.dpt[3,19]*S20
  OM_0_122 = OM_0_121+qd[22]*C20p21*C19
  OM_0_222 = OM_0_221+qd[22]*C20p21*S19
  OM_0_322 = -qd[22]*S20p21
  Ompqp_0_122 = -OM_0_221*qd[22]*S20p21
  Ompqp_0_222 = OM_0_121*qd[22]*S20p21
  Ompqp_0_322 = -qd[22]*C20p21*(qd[20]+qd[21])
  OR_0_124 = OM_0_222*RL_0_324-OM_0_322*RL_0_224
  OR_0_224 = -(OM_0_122*RL_0_324-OM_0_322*RL_0_124)
  OR_0_324 = OM_0_122*RL_0_224-OM_0_222*RL_0_124
  Apqp_0_124 = OM_0_220*OR_0_321+OM_0_222*OR_0_324-OM_0_322*OR_0_224+Ompqp_0_222*RL_0_324-Ompqp_0_322*RL_0_224
  Apqp_0_224 = -(OM_0_120*OR_0_321+OM_0_122*OR_0_324-OM_0_322*OR_0_124+Ompqp_0_122*RL_0_324-Ompqp_0_322*RL_0_124)
  Apqp_0_324 = OM_0_122*OR_0_224-OM_0_222*OR_0_124+Ompqp_0_122*RL_0_224-Ompqp_0_222*RL_0_124-RL_0_321*(OM_0_120*OM_0_120\
   +OM_0_220*OM_0_220)
#
  OM_2_211 = qd[10]+qd[11]
  OM_2_112 = qd[12]*C10p11
  OM_2_312 = -qd[12]*S10p11
  Ompqp_2_112 = -OM_2_211*qd[12]*S10p11
  Ompqp_2_312 = -OM_2_211*qd[12]*C10p11
  OR_2_126 = OM_2_211*RL_2_326-OM_2_312*RL_2_226
  OR_2_226 = -qd[12]*s.dpt[3,14]*C12
  OR_2_326 = OM_2_112*RL_2_226-OM_2_211*RL_2_126
  Apqp_2_126 = OM_2_211*OR_2_326-OM_2_312*OR_2_226-Ompqp_2_312*RL_2_226-qd[10]*qd[10]*s.dpt[3,11]*S10
  Apqp_2_226 = -(OM_2_112*OR_2_326-OM_2_312*OR_2_126+Ompqp_2_112*RL_2_326-Ompqp_2_312*RL_2_126)
  Apqp_2_326 = OM_2_112*OR_2_226-OM_2_211*OR_2_126+Ompqp_2_112*RL_2_226-qd[10]*qd[10]*s.dpt[3,11]*C10
#
  OM_4_115 = -qd[15]*S14
  OM_4_215 = qd[15]*C14
  OM_4_116 = OM_4_115-qd[16]*S14
  OM_4_216 = C14*(qd[15]+qd[16])
  OR_4_316 = -qd[15]*s.dpt[3,15]*S15
  OM_4_117 = OM_4_116+qd[17]*C15p16*C14
  OM_4_217 = OM_4_216+qd[17]*C15p16*S14
  OM_4_317 = -qd[17]*S15p16
  Ompqp_4_117 = -OM_4_216*qd[17]*S15p16
  Ompqp_4_217 = OM_4_116*qd[17]*S15p16
  Ompqp_4_317 = -qd[17]*C15p16*(qd[15]+qd[16])
  OR_4_128 = OM_4_217*RL_4_328-OM_4_317*RL_4_228
  OR_4_228 = -(OM_4_117*RL_4_328-OM_4_317*RL_4_128)
  OR_4_328 = OM_4_117*RL_4_228-OM_4_217*RL_4_128
  Apqp_4_128 = OM_4_215*OR_4_316+OM_4_217*OR_4_328-OM_4_317*OR_4_228+Ompqp_4_217*RL_4_328-Ompqp_4_317*RL_4_228
  Apqp_4_228 = -(OM_4_115*OR_4_316+OM_4_117*OR_4_328-OM_4_317*OR_4_128+Ompqp_4_117*RL_4_328-Ompqp_4_317*RL_4_128)
  Apqp_4_328 = OM_4_117*OR_4_228-OM_4_217*OR_4_128+Ompqp_4_117*RL_4_228-Ompqp_4_217*RL_4_128-RL_4_316*(OM_4_115*OM_4_115\
   +OM_4_215*OM_4_215)

# = = Block_0_3_0_0_0_0 = = 
 
# Symbolic Outputs  

  Jdqd[1] = Apqp_0_124
  Jdqd[2] = Apqp_0_224
  Jdqd[3] = Apqp_0_324
  Jdqd[4] = Apqp_2_126
  Jdqd[5] = Apqp_2_226
  Jdqd[6] = Apqp_2_326
  Jdqd[7] = Apqp_4_128
  Jdqd[8] = Apqp_4_228
  Jdqd[9] = Apqp_4_328

# ====== END Task 0 ====== 

  

