#
#-------------------------------------------------------------
#
#	ROBOTRAN - Version 6.6 (build : february 22, 2008)
#
#	Copyright 
#	Universite catholique de Louvain 
#	Departement de Mecanique 
#	Unite de Production Mecanique et Machines 
#	2, Place du Levant 
#	1348 Louvain-la-Neuve 
#	http://www.robotran.be// 
#
#	==> Generation Date : Mon Jan 27 13:45:24 2020
#
#	==> Project name : delta_fisette_python
#	==> using XML input file 
#
#	==> Number of joints : 23
#
#	==> Function : F 1 : Direct Dynamics (Semi-Explicit formulation) : RNEA
#	==> Flops complexity : 270
#
#	==> Generation Time :  0.010 seconds
#	==> Post-Processing :  0.010 seconds
#
#-------------------------------------------------------------
#
import numpy as np  

def dirdyna(M, c, s,tsim):
  
  q = s.q
  qd = s.qd
  qdd = s.qdd
  frc = s.frc
  trq = s.trq

# === begin imp_aux === 

# === end imp_aux === 

# ===== BEGIN task 0 ===== 

# = = Block_0_0_0_0_0_2 = = 
 
# Trigonometric Variables  

  C4 = np.cos(q[4])
  S4 = np.sin(q[4])
  C5 = np.cos(q[5])
  S5 = np.sin(q[5])

# = = Block_0_0_0_0_0_3 = = 
 
# Trigonometric Variables  

  C6 = np.cos(q[6])
  S6 = np.sin(q[6])
  C7 = np.cos(q[7])
  S7 = np.sin(q[7])

# = = Block_0_0_0_0_0_4 = = 
 
# Trigonometric Variables  

  C8 = np.cos(q[8])
  S8 = np.sin(q[8])
  C9 = np.cos(q[9])
  S9 = np.sin(q[9])

# = = Block_0_0_0_0_0_5 = = 
 
# Trigonometric Variables  

  C11 = np.cos(q[11])
  S11 = np.sin(q[11])

# = = Block_0_0_0_0_0_6 = = 
 
# Trigonometric Variables  

  C12 = np.cos(q[12])
  S12 = np.sin(q[12])

# = = Block_0_0_0_0_0_7 = = 
 
# Trigonometric Variables  

  C13 = np.cos(q[13])
  S13 = np.sin(q[13])

# = = Block_0_0_0_0_0_8 = = 
 
# Trigonometric Variables  

  C15 = np.cos(q[15])
  S15 = np.sin(q[15])
  C16 = np.cos(q[16])
  S16 = np.sin(q[16])

# = = Block_0_0_0_0_0_9 = = 
 
# Trigonometric Variables  

  C17 = np.cos(q[17])
  S17 = np.sin(q[17])

# = = Block_0_0_0_0_0_10 = = 
 
# Trigonometric Variables  

  C18 = np.cos(q[18])
  S18 = np.sin(q[18])

# = = Block_0_0_0_0_0_11 = = 
 
# Trigonometric Variables  

  C20 = np.cos(q[20])
  S20 = np.sin(q[20])
  C21 = np.cos(q[21])
  S21 = np.sin(q[21])

# = = Block_0_0_0_0_0_12 = = 
 
# Trigonometric Variables  

  C22 = np.cos(q[22])
  S22 = np.sin(q[22])

# = = Block_0_0_0_0_0_13 = = 
 
# Trigonometric Variables  

  C23 = np.cos(q[23])
  S23 = np.sin(q[23])

# = = Block_0_2_0_1_0_2 = = 
 
# Backward Dynamics 

  FF4_15 = -(s.frc[1,5]*C5+s.frc[3,5]*S5)
  CF4_35 = s.trq[1,5]*S5-s.trq[3,5]*C5

# = = Block_0_2_0_1_0_3 = = 
 
# Backward Dynamics 

  FF6_17 = -(s.frc[1,7]*C7+s.frc[3,7]*S7)
  CF6_37 = s.trq[1,7]*S7-s.trq[3,7]*C7

# = = Block_0_2_0_1_0_4 = = 
 
# Backward Dynamics 

  FF8_19 = -(s.frc[1,9]*C9+s.frc[3,9]*S9)
  CF8_39 = s.trq[1,9]*S9-s.trq[3,9]*C9

# = = Block_0_2_0_2_0_1 = = 
 
# Backward Dynamics 

  FF13 = -(s.frc[1,3]-s.frc[2,5]*S4-s.frc[2,7]*S6-s.frc[2,9]*S8-FF4_15*C4-FF6_17*C6-FF8_19*C8)
  FF23 = -(s.frc[2,3]+s.frc[2,5]*C4+s.frc[2,7]*C6+s.frc[2,9]*C8-FF4_15*S4-FF6_17*S6-FF8_19*S8)
  FF33 = -(s.frc[3,3]-s.frc[1,5]*S5-s.frc[1,7]*S7-s.frc[1,9]*S9+s.frc[3,5]*C5+s.frc[3,7]*C7+s.frc[3,9]*C9+s.m[3]*s.g[3])

# = = Block_0_2_0_2_0_5 = = 
 
# Backward Dynamics 

  CF211 = -(s.trq[2,11]+s.trq[2,12]*C12+s.trq[2,13]*C13-s.trq[3,12]*S12-s.trq[3,13]*S13)
  CF210 = -(s.trq[2,10]-CF211+s.dpt[3,11]*(C11*(s.frc[1,11]+s.frc[1,12]+s.frc[1,13])+S11*(s.frc[3,11]+s.frc[2,12]*S12+\
   s.frc[2,13]*S13+s.frc[3,12]*C12+s.frc[3,13]*C13)))

# = = Block_0_2_0_2_0_8 = = 
 
# Backward Dynamics 

  CF116 = -(s.trq[1,16]+s.trq[1,17]+s.trq[1,18]+s.dpt[2,16]*(s.frc[2,17]*S17+s.frc[3,17]*C17)+s.dpt[2,17]*(s.frc[2,18]*\
   S18+s.frc[3,18]*C18))
  CF216 = -(s.trq[2,16]+s.trq[2,17]*C17+s.trq[2,18]*C18-s.trq[3,17]*S17-s.trq[3,18]*S18)
  CF316 = -(s.trq[3,16]-s.frc[1,17]*s.dpt[2,16]-s.frc[1,18]*s.dpt[2,17]+s.trq[2,17]*S17+s.trq[2,18]*S18+s.trq[3,17]*C17+\
   s.trq[3,18]*C18)
  CF215 = -(s.trq[2,15]-CF216+s.dpt[3,15]*(C16*(s.frc[1,16]+s.frc[1,17]+s.frc[1,18])+S16*(s.frc[3,16]+s.frc[2,17]*S17+\
   s.frc[2,18]*S18+s.frc[3,17]*C17+s.frc[3,18]*C18)))
  CF14_315 = -(C15*(s.trq[3,15]+CF116*S16-CF316*C16)-S15*(s.trq[1,15]-CF116*C16-CF316*S16-s.dpt[3,15]*(s.frc[2,16]+\
   s.frc[2,17]*C17+s.frc[2,18]*C18-s.frc[3,17]*S17-s.frc[3,18]*S18)))

# = = Block_0_2_0_2_0_11 = = 
 
# Backward Dynamics 

  CF121 = -(s.trq[1,21]+s.trq[1,22]+s.trq[1,23]+s.dpt[2,20]*(s.frc[2,22]*S22+s.frc[3,22]*C22)+s.dpt[2,21]*(s.frc[2,23]*\
   S23+s.frc[3,23]*C23))
  CF221 = -(s.trq[2,21]+s.trq[2,22]*C22+s.trq[2,23]*C23-s.trq[3,22]*S22-s.trq[3,23]*S23)
  CF321 = -(s.trq[3,21]-s.frc[1,22]*s.dpt[2,20]-s.frc[1,23]*s.dpt[2,21]+s.trq[2,22]*S22+s.trq[2,23]*S23+s.trq[3,22]*C22+\
   s.trq[3,23]*C23)
  CF220 = -(s.trq[2,20]-CF221+s.dpt[3,19]*(C21*(s.frc[1,21]+s.frc[1,22]+s.frc[1,23])+S21*(s.frc[3,21]+s.frc[2,22]*S22+\
   s.frc[2,23]*S23+s.frc[3,22]*C22+s.frc[3,23]*C23)))
  CF19_320 = -(C20*(s.trq[3,20]+CF121*S21-CF321*C21)-S20*(s.trq[1,20]-CF121*C21-CF321*S21-s.dpt[3,19]*(s.frc[2,21]+\
   s.frc[2,22]*C22+s.frc[2,23]*C23-s.frc[3,22]*S22-s.frc[3,23]*S23)))

# = = Block_0_3_0_0_0_0 = = 
 
# Symbolic Outputs  

  M[1,1] = s.m[3]
  M[2,2] = s.m[3]
  M[3,3] = s.m[3]
  c[1] = FF13
  c[2] = FF23
  c[3] = FF33
  c[4] = CF4_35
  c[5] = -s.trq[2,5]
  c[6] = CF6_37
  c[7] = -s.trq[2,7]
  c[8] = CF8_39
  c[9] = -s.trq[2,9]
  c[10] = CF210
  c[11] = CF211
  c[12] = -s.trq[1,12]
  c[13] = -s.trq[1,13]
  c[14] = CF14_315
  c[15] = CF215
  c[16] = CF216
  c[17] = -s.trq[1,17]
  c[18] = -s.trq[1,18]
  c[19] = CF19_320
  c[20] = CF220
  c[21] = CF221
  c[22] = -s.trq[1,22]
  c[23] = -s.trq[1,23]

# ====== END Task 0 ====== 

  

