#
#-------------------------------------------------------------
#
#	ROBOTRAN - Version 6.6 (build : february 22, 2008)
#
#	Copyright 
#	Universite catholique de Louvain 
#	Departement de Mecanique 
#	Unite de Production Mecanique et Machines 
#	2, Place du Levant 
#	1348 Louvain-la-Neuve 
#	http://www.robotran.be// 
#
#	==> Generation Date : Mon Jan 27 13:45:23 2020
#
#	==> Project name : delta_fisette_python
#	==> using XML input file 
#
#	==> Number of joints : 23
#
#	==> Function : F 2 : Inverse Dynamics : RNEA
#	==> Flops complexity : 275
#
#	==> Generation Time :  0.000 seconds
#	==> Post-Processing :  0.010 seconds
#
#-------------------------------------------------------------
#
import numpy as np  

def invdyna(phi,s,tsim):
  
  Qq = phi
  
  q = s.q
  qd = s.qd
  qdd = s.qdd
  frc = s.frc
  trq = s.trq

# === begin imp_aux === 

# === end imp_aux === 

# ===== BEGIN task 0 ===== 

# = = Block_0_0_0_0_0_2 = = 
 
# Trigonometric Variables  

  C4 = np.cos(q[4])
  S4 = np.sin(q[4])
  C5 = np.cos(q[5])
  S5 = np.sin(q[5])

# = = Block_0_0_0_0_0_3 = = 
 
# Trigonometric Variables  

  C6 = np.cos(q[6])
  S6 = np.sin(q[6])
  C7 = np.cos(q[7])
  S7 = np.sin(q[7])

# = = Block_0_0_0_0_0_4 = = 
 
# Trigonometric Variables  

  C8 = np.cos(q[8])
  S8 = np.sin(q[8])
  C9 = np.cos(q[9])
  S9 = np.sin(q[9])

# = = Block_0_0_0_0_0_5 = = 
 
# Trigonometric Variables  

  C11 = np.cos(q[11])
  S11 = np.sin(q[11])

# = = Block_0_0_0_0_0_6 = = 
 
# Trigonometric Variables  

  C12 = np.cos(q[12])
  S12 = np.sin(q[12])

# = = Block_0_0_0_0_0_7 = = 
 
# Trigonometric Variables  

  C13 = np.cos(q[13])
  S13 = np.sin(q[13])

# = = Block_0_0_0_0_0_8 = = 
 
# Trigonometric Variables  

  C15 = np.cos(q[15])
  S15 = np.sin(q[15])
  C16 = np.cos(q[16])
  S16 = np.sin(q[16])

# = = Block_0_0_0_0_0_9 = = 
 
# Trigonometric Variables  

  C17 = np.cos(q[17])
  S17 = np.sin(q[17])

# = = Block_0_0_0_0_0_10 = = 
 
# Trigonometric Variables  

  C18 = np.cos(q[18])
  S18 = np.sin(q[18])

# = = Block_0_0_0_0_0_11 = = 
 
# Trigonometric Variables  

  C20 = np.cos(q[20])
  S20 = np.sin(q[20])
  C21 = np.cos(q[21])
  S21 = np.sin(q[21])

# = = Block_0_0_0_0_0_12 = = 
 
# Trigonometric Variables  

  C22 = np.cos(q[22])
  S22 = np.sin(q[22])

# = = Block_0_0_0_0_0_13 = = 
 
# Trigonometric Variables  

  C23 = np.cos(q[23])
  S23 = np.sin(q[23])

# = = Block_0_1_0_0_0_0 = = 
 
# Backward Dynamics 

  Cq121 = -(s.trq[1,21]+s.trq[1,22]+s.trq[1,23]+s.dpt[2,20]*(s.frc[2,22]*S22+s.frc[3,22]*C22)+s.dpt[2,21]*(s.frc[2,23]*\
   S23+s.frc[3,23]*C23))
  Cq221 = -(s.trq[2,21]+s.trq[2,22]*C22+s.trq[2,23]*C23-s.trq[3,22]*S22-s.trq[3,23]*S23)
  Cq321 = -(s.trq[3,21]-s.frc[1,22]*s.dpt[2,20]-s.frc[1,23]*s.dpt[2,21]+s.trq[2,22]*S22+s.trq[2,23]*S23+s.trq[3,22]*C22+\
   s.trq[3,23]*C23)
  Cq220 = -(s.trq[2,20]-Cq221+s.dpt[3,19]*(C21*(s.frc[1,21]+s.frc[1,22]+s.frc[1,23])+S21*(s.frc[3,21]+s.frc[2,22]*S22+\
   s.frc[2,23]*S23+s.frc[3,22]*C22+s.frc[3,23]*C23)))
  Cq319 = -(C20*(s.trq[3,20]+Cq121*S21-Cq321*C21)-S20*(s.trq[1,20]-Cq121*C21-Cq321*S21-s.dpt[3,19]*(s.frc[2,21]+\
   s.frc[2,22]*C22+s.frc[2,23]*C23-s.frc[3,22]*S22-s.frc[3,23]*S23)))
  Cq116 = -(s.trq[1,16]+s.trq[1,17]+s.trq[1,18]+s.dpt[2,16]*(s.frc[2,17]*S17+s.frc[3,17]*C17)+s.dpt[2,17]*(s.frc[2,18]*\
   S18+s.frc[3,18]*C18))
  Cq216 = -(s.trq[2,16]+s.trq[2,17]*C17+s.trq[2,18]*C18-s.trq[3,17]*S17-s.trq[3,18]*S18)
  Cq316 = -(s.trq[3,16]-s.frc[1,17]*s.dpt[2,16]-s.frc[1,18]*s.dpt[2,17]+s.trq[2,17]*S17+s.trq[2,18]*S18+s.trq[3,17]*C17+\
   s.trq[3,18]*C18)
  Cq215 = -(s.trq[2,15]-Cq216+s.dpt[3,15]*(C16*(s.frc[1,16]+s.frc[1,17]+s.frc[1,18])+S16*(s.frc[3,16]+s.frc[2,17]*S17+\
   s.frc[2,18]*S18+s.frc[3,17]*C17+s.frc[3,18]*C18)))
  Cq314 = -(C15*(s.trq[3,15]+Cq116*S16-Cq316*C16)-S15*(s.trq[1,15]-Cq116*C16-Cq316*S16-s.dpt[3,15]*(s.frc[2,16]+\
   s.frc[2,17]*C17+s.frc[2,18]*C18-s.frc[3,17]*S17-s.frc[3,18]*S18)))
  Cq211 = -(s.trq[2,11]+s.trq[2,12]*C12+s.trq[2,13]*C13-s.trq[3,12]*S12-s.trq[3,13]*S13)
  Cq210 = -(s.trq[2,10]-Cq211+s.dpt[3,11]*(C11*(s.frc[1,11]+s.frc[1,12]+s.frc[1,13])+S11*(s.frc[3,11]+s.frc[2,12]*S12+\
   s.frc[2,13]*S13+s.frc[3,12]*C12+s.frc[3,13]*C13)))
  Fq18 = -(s.frc[1,9]*C9+s.frc[3,9]*S9)
  Cq38 = s.trq[1,9]*S9-s.trq[3,9]*C9
  Fq16 = -(s.frc[1,7]*C7+s.frc[3,7]*S7)
  Cq36 = s.trq[1,7]*S7-s.trq[3,7]*C7
  Fq14 = -(s.frc[1,5]*C5+s.frc[3,5]*S5)
  Cq34 = s.trq[1,5]*S5-s.trq[3,5]*C5
  Fq13 = -(s.frc[1,3]-qdd[1]*s.m[3]-s.frc[2,5]*S4-s.frc[2,7]*S6-s.frc[2,9]*S8-Fq14*C4-Fq16*C6-Fq18*C8)
  Fq23 = -(s.frc[2,3]-qdd[2]*s.m[3]+s.frc[2,5]*C4+s.frc[2,7]*C6+s.frc[2,9]*C8-Fq14*S4-Fq16*S6-Fq18*S8)
  Fq33 = -(s.frc[3,3]-s.frc[1,5]*S5-s.frc[1,7]*S7-s.frc[1,9]*S9+s.frc[3,5]*C5+s.frc[3,7]*C7+s.frc[3,9]*C9-s.m[3]*(qdd[3]\
   -s.g[3]))

# = = Block_0_2_0_0_0_0 = = 
 
# Symbolic Outputs  

  Qq[1] = Fq13
  Qq[2] = Fq23
  Qq[3] = Fq33
  Qq[4] = Cq34
  Qq[5] = -s.trq[2,5]
  Qq[6] = Cq36
  Qq[7] = -s.trq[2,7]
  Qq[8] = Cq38
  Qq[9] = -s.trq[2,9]
  Qq[10] = Cq210
  Qq[11] = Cq211
  Qq[12] = -s.trq[1,12]
  Qq[13] = -s.trq[1,13]
  Qq[14] = Cq314
  Qq[15] = Cq215
  Qq[16] = Cq216
  Qq[17] = -s.trq[1,17]
  Qq[18] = -s.trq[1,18]
  Qq[19] = Cq319
  Qq[20] = Cq220
  Qq[21] = Cq221
  Qq[22] = -s.trq[1,22]
  Qq[23] = -s.trq[1,23]

# ====== END Task 0 ====== 

  

