# -*- coding: utf-8 -*-

#joint_forces.py
#@author: Olivier Lantsoght
#
#Created on 23/05/2019
#Last update on 23/05/2019
#
#Copyright 2019 Universite Catholique de Louvain


import numpy as np

def user_JointForces(mbs,tsim):
    """ Compute the force in the joint. it fill the Qq matrix.
    
    :param mbs: The mbs Data structure
    :param tsim: the simulation time
    
    """
    # cleaning previous forces
    mbs.Qq[1:] = 0
    
    # print("user_JointForces (Template) : This function should not be called")
    
    #==========================================================================
    # BEGIN OF USER CODE
    #==========================================================================
    # Example: damping in joint number 5
    # D = 0.5 # N/(m/s)
    # mbs.Qq[5] = -D * mbs.qd[5]
    
    friction_mu = 10
    
    ind_art = mbs.njoint+1
    mbs.Qq[4:ind_art] = -friction_mu * mbs.qd[4:ind_art]
    
    return
